function terminal(s) 
  s[#s + 1] = { 
		_keyts = 0;
		_key = 0;
    _keypress = false;
    path = 'C:\\';
    entry = '';
    noinv = true;
    status = 'command';
    theme = 'terminal';
    format_percent = 0;
    mx = false;
    my = false;
    directory_structure = {
			['C:'] = {
				['DOCS'] = {
					['PASSWORD.TXT'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						else
							s:push(translate_now("terminal_locale", 'bad_command'));
						end;
					end;
					['CRYPT.COM'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						elseif command == '' then
							if not args then
								s:push(translate_now("terminal_locale", 'crypt_usage'));
							else
								local new_args = {};
								for i in string.gmatch(args, "%S+") do
									if i and i ~= '' then
										new_args[#new_args + 1] = i;
									end;
								end;

								if #new_args > 2 then
									s:push(translate_now("terminal_locale", 'crypt_usage'));
									return
								elseif #new_args < 2 then
                  s:push(translate_now("terminal_locale", 'crypt_key_unset'));
									return;
								end;
								local name, path;
								name, path = s:walk_directory(new_args[1], true);
								
								if name ~= nil and path == 'C:\\DOCS\\PASSWORD.TXT' then
									name, path = s:walk_directory(new_args[2], true);
									if name ~= nil and path == 'C:\\DOCS\\KEY.TXT' then
										s:push(translate_now("terminal_locale", 'crypt_key_locked'));
										s.status = 'crypt';
										return true;
									else
										s:push(translate_now("terminal_locale", 'crypt_invalid_key'));
									end;
									
								else
									s:push(translate_now("terminal_locale", 'crypt_unencrypted'));
								end;
							end;
						end;
					end;
					['CRYPT.CFG'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push('[MAIN]');
							s:push('ALGORITHM=AES');
							s:push('[RSA]');
							s:push('HARDWARE=FALSE');
							s:push(';KEY=KEY.TXT');
						else
							s:push(translate_now("terminal_locale", 'bad_command'));
						end;
					end;
					['KEY.TXT'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						else
							s:push(translate_now("terminal_locale", 'bad_command'));
						end;
					end;
				},
				['SYSTEM'] = {
					['CONNECT.EXE'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						elseif command == '' then
							s.status = 'connect';
							return true;
						end;
					end;
					['FORMAT.COM'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						elseif command == '' then
							if args and args:lower() == 'c:' then
								s.status = 'format';
								return true;
							elseif args and string.match(args, "^[A-z]:$") == args then
								s:push(translate_now("terminal_locale", 'format_invalid_device'));
							else
                s:push(translate_now("terminal_locale", 'format_usage'));
							end;
						end;
					end;
					['HELP.COM'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						elseif command == '' then
              s:push(translate_now("terminal_locale", 'help_cd'));
              s:push(translate_now("terminal_locale", 'help_dir'));
              s:push(translate_now("terminal_locale", 'help_disk'));
              s:push(translate_now("terminal_locale", 'help_connect'));
              s:push(translate_now("terminal_locale", 'help_format'));
              s:push(translate_now("terminal_locale", 'help_help'));
              s:push(translate_now("terminal_locale", 'help_print'));
              s:push(translate_now("terminal_locale", 'help_exit'));
              s:push(translate_now("terminal_locale", 'help_com_exe'));
						end;
					end;
					['PRINT.COM'] = function(s, command, args)
						if command == 'PRINT.COM' then
							s:push(translate_now("terminal_locale", 'binary_data'));
						elseif command == '' then
							if args then
								local cmd = s:walk_directory(args:upper(), true);
								if type(cmd) == 'function' then
									cmd(s, 'PRINT.COM', '')
								else
									s:push(translate_now("terminal_locale", 'print_no_file'));
								end;
							else
								s:push(translate_now("terminal_locale", 'print_usage'));
							end;
						end;
					end;
				},
				['AUTOEXEC.BAT'] = function(s, command, args)
					if command == 'PRINT.COM' then
						s:push('SET PATH=C:\\SYSTEM');
            s:push(translate_now("terminal_locale", 'connect_comment'));
					elseif command == '' then
						s:push(translate_now("terminal_locale", 'bad_command'));
					end;
				end;
				['CONFIG.SYS'] = function(s, command, args)
					if command == 'PRINT.COM' then
						s:push('DEVICE=C:\\SYSTEM\\HIMEM.SYS');
						s:push('DOS=HIGH,UMB');
						s:push('FILES=30');
						s:push('STACKS=0,0');
						s:push('BUFFERS=20');
						s:push('DEVICE=C:\\SYSTEM\\EMM386.EXE');
						s:push('DEVICE=C:\\SYSTEM\\TOWER.SYS');
					elseif command == '' then
						s:push(translate_now("terminal_locale", 'bad_command'));
					end;
				end;
				['COMMAND.COM'] = function(s, command, args)
					if command == 'PRINT.COM' then
						s:push(translate_now("terminal_locale", 'binary_data'));
					elseif command == '' then
						s:push(translate_now("terminal_locale", 'command_already_started'));
					end;
				end;
				['HELLO.TXT'] = function(s, command, args)
					if command == 'PRINT.COM' then
            s:push(translate_now("terminal_locale", 'hello_txt'));
					elseif command == '' then
						s:push(translate_now("terminal_locale", 'bad_command'));
					end;
				end;
			}
		};
	};
  
  s.disp = '';
	s.nofollow = true;
	s.nofading = true;
  
  s.query_formatter = function(s, path, entry)
		if s.status == 'command' then
			return s.path .. '>' .. s.entry .. '_';
		elseif s.status == 'crypt' or s.status == 'connect' then
			return translate_now("terminal_locale", 'query_password') .. entry .. '_';
		elseif s.status == 'format' then
			return translate_now("terminal_locale", 'query_type_yes') .. entry .. '_';
		elseif s.status == 'wait_format' then
			return translate_now("terminal_locale", 'query_formatting') .. " " .. tostring(s.format_percent) .. '%';
		elseif s.status == 'format_done' then
		end;
		return '';
	end;
  
  s.command_preprocessor = function(s, command)
		if s.status == 'crypt' then
			s.status = 'command';
			s:push(translate_now("terminal_locale", 'query_password') .. command);
			if command == password1 then
				s:push(password2);
				s:push('');
			else
				s:push(translate_now("terminal_locale", 'invalid_password'));
				s:push('');
			end;
			s.entry = '';
			return true;
		elseif s.status == 'connect' then
			s.entry = '';
			s.status = 'command';
			s:push(translate_now("terminal_locale", 'query_password') .. command);
			if command == password2 then
        if irradiated then
          snd.music('sound/bgm_ending_space_irradiated.ogg');
        else
          snd.music('sound/bgm_ending_space.ogg');
        end;
        if solarscale_with_me then
          walk('ending_solarscale_pre');
        else
          walk('ending_dissolving_tower_solarscale');
        end;
        
			else
				s:push(translate_now("terminal_locale", 'invalid_password_2'));
			end;
			
			return true;
		elseif s.status == 'format' then
			s.status = 'format';
			s.entry = '';
			s:push(translate_now("terminal_locale", 'query_type_yes') .. command);
			--s:push("Type 'Yes' to confirm:" .. command);
			if command:lower() == 'yes' then
				s.status = 'wait_format';
        if instead.tiny then
          _'#fail': enable();
        end;
				timer:set(25);
			else
				s:push(translate_now("terminal_locale", 'operation_cancelled'));
				s.status = 'command';
			end;
			
			return true;
		elseif s.status == 'wait_format' then
			s.entry = '';
			return true;
		end;
	end;
  
  s.puch_cmd = function(s, text)
    s:push_line(text);
  end;
  
  s.push = function(s, text)
    local lines = split(text, '^');
    
    for _, l in ipairs(lines) do
      s:push_line(l);
    end;
  end;
  
  s.onenter = function(s)
    s.path = 'C:\\';
    s.entry = '';
    s.msg = '';
    
		s:process_directory_structure(s.directory_structure['C:']);
		s:push(translate_now("terminal_locale", 'tower_os_line_1'));
		s:push('');
		s:push(translate_now("terminal_locale", 'tower_os_line_2'));
		s:push('');
		s:push(translate_now("terminal_locale", 'tower_os_line_3'));
		s:push('');

		s:makekeyboard();
    
    instead.autosave();
	end;
  
  s.process_command = function(s, str)
		s:puch_cmd(s.path .. '>' .. str);
		
		local rval = {}
		
		for i in string.gmatch(str, "%S+") do
			if (#rval > 0) then
				if rval[2] then
					rval[2] = rval[2] .. ' ' .. i;
				else
					rval[2] = i;
				end;
			else
				rval[1] = i;
			end;
			
		end;
		
		return rval;
	end;
  
  s.process_directory_structure = function(s, current, parent)
		current['.'] = current;
		current['..'] = parent;
		for k,v in pairs(current) do
			if k ~= '.' and k ~= '..' and type(v) == 'table' then
				s:process_directory_structure(v, current);
			end;
		end;
	end;
  
	s.walk_directory = function(s, path, no_replace)
		local location = s.directory_structure;
		
		if path:sub(1, 2):upper() ~= 'C:' then
			path = s.path .. path;
		end;
		
		local spath = {};
		
		for part in string.gmatch(path, "[^\\\\]+") do
			part = part:upper();
			if part == '.' then
			elseif part == '..' then
				spath[#spath] = nil;
			else
				spath[#spath + 1] = part;
			end;
			local oloc = location;
			location = location[part];
			if not no_replace then
				if location == nil then
					location = oloc[part .. '.COM'];
				end;
				if location == nil then
					location = oloc[part .. '.EXE'];
				end;
			end;

			if location == nil then
				return nil, nil
			end;
		end;
		return location, cat_list(spath, '\\');
	end;
  
	s.call_command = function(s, command, args)
		local r = false;
		if command == '' or not command then
			return
    end;
    
    command = command:lower();
    
		if command == 'dir' then
			local rval = {};
		
			local subdir = s:walk_directory(s.path);
			 local sort = function(s1, s2)
				 if type(subdir[s1]) == 'function' and type(subdir[s2]) == 'table' then
					 return false;
				 elseif type(subdir[s1]) == 'table' and type(subdir[s2]) == 'function' then
					 return true;
				 end;
				 return s1 < s2;
			end;
			
			for k, v in pairs(subdir) do
				rval[#rval + 1] = k;
			end;
			
			table.sort(rval, sort);
			
			for i, v in ipairs(rval) do
				s:push(v);
			end;
		elseif command == 'cd' then
			if args then
				args = args:upper();
				local dir, path = s:walk_directory(args)
				if type(dir) == 'table' then
					s.path = path .. '\\';
				else
          s:push(translate_now("terminal_locale", 'cd_invalid_directory', {path=args}));
				end;
			else
        s:push(translate_now("terminal_locale", 'cd_usage'));
			end;
		elseif command == 'ver' then
			s:push(translate_now("terminal_locale", 'tower_os_line_2'));
		elseif command == 'exit' then
			walk('tower_level_4_room_2');
      return true;
    elseif command == 'rm' and args and #args >= 2 and (args == '-rf . /' or args == '-rf /') then
      s:push(translate_now("terminal_locale", random_phrase({'unix_line_3', 'unix_line_4'})));
    elseif command == 'sudo' or command == 'su' or command == 'ls' or command == 'rm' then
      s:push(translate_now("terminal_locale", random_phrase({'unix_line_1', 'unix_line_2'})));
    elseif command == 'cat' then
      s:push(translate_now("terminal_locale", random_phrase({'cat_line_1', 'cat_line_2', 'cat_line_3'})));
    elseif command == 'more' or command == 'less' then
      s:push(translate_now("terminal_locale", 'more_line_1'));
    elseif command == 'head' or command == 'tail' then
      s:push(translate_now("terminal_locale", random_phrase({'head_line_1', 'head_line_2'})));
    elseif command == 'echo' then
      if args then
        s:push(args);
      else
        s:push('');
      end;
		elseif command == 'help' or command:lower() == 'help.com' then
			r = s.directory_structure['C:']['SYSTEM']['HELP.COM'](s, '', args);
		elseif command == 'print' or command:lower() == 'print.com' then
			r = s.directory_structure['C:']['SYSTEM']['PRINT.COM'](s, '', args);
		elseif command == 'format' or command:lower() == 'format.com' then
			r = s.directory_structure['C:']['SYSTEM']['FORMAT.COM'](s, '', args);
		elseif command == 'connect' or command:lower() == 'connect.exe' then
			r = s.directory_structure['C:']['SYSTEM']['CONNECT.EXE'](s, '', args);
		elseif #command == 2 and command:sub(2, 2) == ':' then
			if (s.directory_structure[command]) then
				s.path = command:upper() .. '\\';
			else
        s:push(translate_now("terminal_locale", 'format_invalid_device'));
			end;
		else
			local cmd = s:walk_directory(command:upper())
			if type(cmd) == 'function' then
				r = cmd(s, '', args);
			else
        s:push(translate_now("terminal_locale", 'bad_command'));
			end;
		end;
		if not r then
			s:push('');
		end;
	end;
  
  return room(s);
end;