include "terminal/common.lua"

obj {
	nam = 'tower_key_0';
	value = 1;
  color = 'red';
	disp = translate("tower_locale", 'tower_red_key_disp');
	disp2 = translate("tower_locale", 'tower_red_key_disp2');
	disp3 = translate("tower_locale", 'tower_red_key_disp3');
	inv = translate("tower_locale", 'tower_red_key_inv');
}

obj {
	nam = 'tower_key_1';
	value = 2;
  color = 'gold';
	disp = translate("tower_locale", 'tower_gold_key_disp');
	disp2 = translate("tower_locale", 'tower_gold_key_disp2');
	disp3 = translate("tower_locale", 'tower_gold_key_disp3');
	inv = translate("tower_locale", 'tower_gold_key_inv');
}

obj {
	nam = 'tower_key_2';
	value = 3;
  color = 'blue';
	disp = translate("tower_locale", 'tower_blue_key_disp');
	disp2 = translate("tower_locale", 'tower_blue_key_disp2');
	disp3 = translate("tower_locale", 'tower_blue_key_disp3');
	inv = translate("tower_locale", 'tower_blue_key_inv');
}

obj {
	nam = 'tower_key_3';
	value = 4;
  color = 'green';
	disp = translate("tower_locale", 'tower_green_key_disp');
	disp2 = translate("tower_locale", 'tower_green_key_disp2');
	disp3 = translate("tower_locale", 'tower_green_key_disp3');
	inv = translate("tower_locale", 'tower_green_key_inv');
}

obj {
	nam = 'tower_level_2_key';
	disp = translate("tower_locale", 'tower_level_2_key_disp');
	inv = translate("tower_locale", 'tower_level_2_key_dsc');
}

obj {
	nam = 'tower_hint_1';
	disp = translate("tower_locale", 'tower_hint_1_disp');
	inv = function(s)
    return translate_now("tower_locale", 'tower_hint_1_inv', {target=level_1_target});
  end;
}

obj {
  nam = 'tower_walls';
  act = function(s)
    if tower_accept_level == 0 then
      return translate_now("tower_locale", 'tower_accept_1_walls');
    elseif tower_accept_level == 1 then
      return translate_now("tower_locale", 'tower_accept_2_walls');
    elseif tower_accept_level == 2 then
      tower_accept_level = 3;
      if solarscale_with_me then
        walkin('tower_walls_dlg_solarscale');
      else
        walkin('tower_walls_dlg_alone');
      end;
    elseif tower_accept_level == 3 then
      return translate_now("tower_locale", 'tower_accept_3_walls');
    end;
  end;
};

dlg {
  nam = 'tower_walls_dlg_solarscale';
  theme = 'tower';
  disp = function(s)
    return std.call(from(), 'disp');
  end;
  pic = function(s)
    return _'solarscale_ally_dlg':pic();
  end;
  enter = function(s)
    return translate_now("tower_locale", 'walls_dlg_enter') .. ' ' .. translate_now("tower_locale", 'walls_dlg_enter_solarscale');
  end;
  phr = {
    only=true;
    {translate("tower_locale", 'walls_dlg_p1'), translate("tower_locale", 'walls_dlg_p1_r'), next='#second'};
    {translate("tower_locale", 'walls_dlg_p2'), translate("tower_locale", 'walls_dlg_p2_r'), next='#second'};
    {false, '#second', 
      {translate("tower_locale", 'walls_dlg_p3'), function(s)
          solarscale_tower = true;
          return translate_now("tower_locale", 'walls_dlg_p3_r');
      end};
      {translate("tower_locale", 'walls_dlg_p4'), function(s)
          p(translate_now("tower_locale", 'walls_dlg_p4_r'));
          walkout();
      end};
      {translate("tower_locale", 'walls_dlg_p5'), function(s)
        p(translate_now("tower_locale", 'walls_dlg_p5_r'));
        walkout();
      end};
    };
  };
};

dlg {
  nam = 'tower_walls_dlg_alone';
  theme = 'tower';
  disp = function(s)
    return std.call(from(), 'disp');
  end;
  pic = function(s)
    return std.call(from(), 'pic');
  end;
  enter = translate("tower_locale", 'walls_dlg_enter');
  phr = {
    {translate("tower_locale", 'walls_dlg_p6'), translate("tower_locale", 'walls_dlg_p6_r')};
    {translate("tower_locale", 'walls_dlg_p4'), translate("tower_locale", 'walls_dlg_p4_r')};
    {translate("tower_locale", 'walls_dlg_p5'), function(s) p(translate_now("tower_locale", 'walls_dlg_p5_r'));  walkout(); end;};
  };
};

obj {
	nam = 'flask';
	disp = translate("tower_locale", 'flask_disp');
	disp2 = translate("tower_locale", 'flask_disp2');
	disp3 = translate("tower_locale", 'flask_disp3');
	inv = translate("tower_locale", 'flask_inv');
}

obj {
	nam = 'potion_open';
	disp = translate("tower_locale", 'potion_open_disp');
	disp2 = translate("tower_locale", 'potion_open_disp2');
	disp3 = translate("tower_locale", 'potion_open_disp3');
	inv = translate("tower_locale", 'potion_open_inv');
}

obj {
	nam = 'potion_light';
	disp = translate("tower_locale", 'potion_light_disp');
	disp2 = translate("tower_locale", 'potion_light_disp2');
	disp3 = translate("tower_locale", 'potion_light_disp3');
	inv = function(s)
		if here()^'tower_level_3_room_2' then
			remove('potion_light', pl);
			here().light = true;
			_'#door':enable();
			_'#shelves':enable();
			_'level_3_room_2_down':enable()
			_'#darkness':disable();
			return translate_now("tower_locale", 'potion_light_inv_used');
		else
			return translate_now("tower_locale", 'potion_light_inv');
		end;
	end;
}

obj {
	nam = 'candle';
	disp = translate("tower_locale", 'candle_disp');
	disp2 = translate("tower_locale", 'candle_disp2');
	disp3 = translate("tower_locale", 'candle_disp3');
	inv = translate("tower_locale", 'candle_inv');
}

obj {
	nam = 'potion_enrichment';
	disp = translate("tower_locale", 'potion_enrichment_disp');
	disp2 = translate("tower_locale", 'potion_enrichment_disp2');
	disp3 = translate("tower_locale", 'potion_enrichment_disp3');
	inv = translate("tower_locale", 'potion_enrichment_inv');
}

obj {
	nam = 'emerald';
	disp = translate("tower_locale", 'emerald_disp');
	disp2 = translate("tower_locale", 'emerald_disp2');
	disp3 = translate("tower_locale", 'emerald_disp3');
	inv = translate("tower_locale", 'emerald_inv');
}

obj {
	nam = 'password_note';
	disp = translate("tower_locale", 'password_note_disp');
	disp2 = translate("tower_locale", 'password_note_disp2');
	disp3 = translate("tower_locale", 'password_note_disp3');
	inv = function(s)
    return translate_now("tower_locale", 'password_note_inv', {password=password1});
  end;
}

obj {
	nam = 'tool_box';
	dsc = translate("tower_locale", 'tool_box_dsc');
	disp = translate("tower_locale", 'tool_box_disp');
	disp2 = translate("tower_locale", 'tool_box_disp2');
	disp3 = translate("tower_locale", 'tool_box_disp3');
	inv = translate("tower_locale", 'tool_box_inv');
};

obj {
	state = 0; -- 0 - empty, 1 - cold water, 2 - hot water
	nam = 'kettle';
	disp = function(s)
		if s.state == 0 then
			return translate_now("tower_locale", 'kettle_disp');
		elseif s.state == 1 then
			return translate_now("tower_locale", 'kettle_disp_water');
		elseif s.state == 2 then
			return translate_now("tower_locale", 'kettle_disp_hot_water');
		end;
	end;
	disp2 = translate("tower_locale", 'kettle_disp2');
	disp3 = translate("tower_locale", 'kettle_disp3');
	inv = function(s)
    p(translate_now("tower_locale", 'kettle_inv'));
		if s.state == 0 then
			p(translate_now("tower_locale", 'kettle_inv_empty'));
		elseif s.state == 1 then
			p(translate_now("tower_locale", 'kettle_inv_water'));
		elseif s.state == 2 then
			 p(translate_now("tower_locale", 'kettle_inv_hot_water'));
		end;
	end;
  dsc = translate("tower_locale", 'kettle_dsc');
  tak = function(s)
    if not _'solarscale_ally'.tea_asked then
      p(translate_now("tower_locale", 'kettle_tak_no'));
      return false;
    else
      return translate_now("tower_locale", 'kettle_tak');
    end;
  end;
}

obj {
  nam = 'teabox';
  disp = translate("tower_locale", 'teabox_disp');
  inv = translate("tower_locale", 'teabox_inv');
};

obj {
  state = 0; -- 0 - empty, 1 -- has tea leaves, 2 -- has tea
  nam = 'teapot';
  disp = translate_now("tower_locale", 'teapot_disp');
  inv = function(s)
    if s.state == 0 then
      return translate_now("tower_locale", 'teapot_inv_empty');
    elseif s.state == 1 then
      return translate_now("tower_locale", 'teapot_inv_leaves');
    elseif s.state == 2 then
      return translate_now("tower_locale", 'teapot_inv_tea');
    end;
  end;
  used = function(s, o)
    if o ^ 'kettle' then
      if o.state == 0 then
        return translate_now("tower_locale", 'teapot_used_empty_kettle');
      elseif o.state == 1 then
        return translate_now("tower_locale", 'teapot_used_cold_water');
      elseif s.state == 0 then
        return translate_now("tower_locale", 'teapot_used_no_tea');
      elseif s.state == 2 then
        return translate_now("tower_locale", 'teapot_used_already');
      else
        s.state = 2;
        return translate_now("tower_locale", 'teapot_used_filled');
      end;
    elseif o ^ 'teabox' then
      if s.state == 1 then
        return translate_now("tower_locale", 'teapot_used_already_tea');
      elseif s.state == 2 then
        return translate_now("tower_locale", 'teapot_used_already');
      else
        s.state = 1;
        return translate_now("tower_locale", 'teapot_used_tea_added');
      end;
    else
      return false;
    end;
  end;
};

obj {
  state = 0;
  nam = 'cups';
  disp = translate("tower_locale", 'cups_disp');
  inv = translate("tower_locale", 'cups_inv_act');
  dsc = translate("tower_locale", 'cups_dsc');
  act = translate("tower_locale", 'cups_inv_act');
  used = function(s, o)
    if s.state ~= 0 then
      return translate_now("tower_locale", 'cups_no_need')
    end;
    
    if o ^ 'kettle' then
      return translate_now("tower_locale", 'cups_kettle');
    elseif o ^ 'teapot' then
      if o.state == 2 then
        if have(s, pl) then
          return translate_now("tower_locale", 'cups_should_be_placed');
        else
          remove('cups', here());
          remove('teapot', me());
          remove('kettle', me());
          remove('teabox', me());
          had_tea = true;
          walkin('solarscale_tea_dlg');
        end;
      else
        return translate_now("tower_locale", 'cups_no_tea');
      end;
    else
      return false;
    end;
  end;
};

room {
	keys_taken = false;
	theme = 'tower';
	nam = 'tower_level_1';
	pic = 'images/tower_level_1.png';
	disp = translate("tower_locale", 'tower_level_1_disp');
	decor = translate("tower_locale", 'tower_level_1_decor');
	way = {
		path {translate("tower_locale", 'transition_leave'), "ending_left"};
		path {"level_1_next_room", translate("tower_locale", 'transition_room'), "tower_level_1_room_2"}:disable();
		path {"level_1_up", translate("tower_locale", 'transition_upstairs'), "tower_level_2"}:disable();
	};
	enter = function(s)
		snd.music('sound/bgm_tower.ogg');
    instead.autosave();
	end;
  exit = function(s)
    _'ending_left'.state = 0;
  end;
}: with {
	'tower_walls',
	obj {
		nam = '#ceiling';
		act = translate("tower_locale", 'tower_level_1_ceiling');
	};
	obj {
		state = 0;
		nam = '#tables';
		act = function(s)
			p(translate_now("tower_locale", 'tower_level_1_tables'));
			if s.state == 0 then
				s.state = 1;
				p(translate_now("tower_locale", 'tower_level_1_tables_box'));
				_'tower_box':enable();
			end;
		end;
	};
	obj {
		state = 0;
		nam = '#candelabra';
		act = function(s)
			p(translate_now("tower_locale", 'tower_level_1_candelabra'));
			if s.state == 0 then
				s.state = 1;
				p(translate_now("tower_locale", 'tower_level_1_candelabra_keys'));
				_'#keys':enable();
			else
				if not candle_taken then
					s.state = 2;
					take('candle');
					candle_taken = true;
					p(translate_now("tower_locale", 'tower_candelabra_candle_taken'));
				else
					if s.state == 2 then
						p(translate_now("tower_locale", 'tower_candelabra_candle_missing'));
					end;
				end;
			end;

		end;
	};
	obj {
		nam = '#chairs';
		act = translate("tower_locale", 'tower_level_1_chairs');
	};
	obj {
		nam = '#keys';
		dsc = translate("tower_locale", 'tower_level_1_keys');
		act = function(s)
			here().keys_taken = true;
			take('tower_key_0');
			take('tower_key_1');
			take('tower_key_2');
			take('tower_key_3');
			remove('#keys', here());
			return translate_now("tower_locale", 'tower_level_1_keys_take');
		end;
	}:disable();
	obj {
		nam = 'tower_box';
		disp = translate("tower_locale", 'tower_level_1_box_disp');
		dsc = translate("tower_locale", 'tower_level_1_box_dsc');
		tak = function(s)
			take('tower_hint_1');
			return translate_now("tower_locale", 'tower_level_1_box_tak');
		end;
		inv = function(s)
			if here()^'inside_box' then
				return translate_now("tower_locale", 'tower_level_1_box_inv');
			end;
			walkin('inside_box');
		end;
	}:disable();
	obj {
		state = false;
		nam = '#tower_1_door';
		dsc = function(s)
			if s.state then
				return translate_now("tower_locale", 'tower_level_1_door_open');
			else
				return translate_now("tower_locale", 'tower_level_1_door_closed');
			end;
		end;
		act = function(s)
			if s.state then
				return translate_now("tower_locale", 'tower_level_1_door_act_open');
			else
				return translate_now("tower_locale", 'tower_level_1_door_act_closed');
			end;
		end;
		used = function(s, o)
			if o^'hidden_key' or o^'tower_key_0' or o^'tower_key_1' or o^'tower_key_2' or o^'tower_key_3' then
				return translate_now("common_locale", 'key_does_not_fit');
			elseif o^'tower_level_2_key' then
				remove('tower_level_2_key', pl);
				s.state = true;
				enable('level_1_up');
				return translate_now("tower_locale", 'tower_level_1_door_use_correct_key');
			end;
      
      return false;
		end;
	}:with {
		obj {
			nam = '#stairwell';
			act = translate("tower_locale", 'tower_level_1_stairwell');
		}
	};
	obj {
		nam = '#tower_1_kitchen_door';
		dsc = translate("tower_locale", 'tower_level_1_kitchen_door');
		act = function(s)
			if not _'level_1_next_room':disabled() then
				return translate_now("tower_locale", 'tower_level_1_kitchen_door_act_open');
			else
				return translate_now("tower_locale", 'tower_level_1_kitchen_door_act_closed');
			end;
		end;
		used = function(s, o)
			if o^'tower_level_2_key' or o^'tower_key_0' or o^'tower_key_1' or o^'tower_key_2' or o^'tower_key_3' or o^'hidden_key' then
				return translate_now("tower_locale", 'tower_level_1_kitchen_door_used_key');
			end;

			if o^'potion_open' then
				return translate_now("tower_locale", 'tower_level_1_kitchen_door_used_potion');
			end;

			return false;
		end;
	};
}

room {
	nam = 'inside_box';
	disp = translate("tower_locale", 'tower_level_1_box_disp');
  theme = 'tower';
	nofollow = true;
  pic = function(s)
    local pic = 'images/box/box_bg.png';
    local sum = tostring(s:sum());
    local num1 = "0";
    local num2 = "0";
    local num3 = "0";
    
    if string.len(sum) == 3 then
      num1 = string.sub(sum, 1, 1);
      num2 = string.sub(sum, 2, 2);
      num3 = string.sub(sum, 3, 3);
    elseif string.len(sum) == 2 then
      num2 = string.sub(sum, 1, 1);
      num3 = string.sub(sum, 2, 2);
    else
      num3 = sum;
    end;
  
    pic = pic .. ';images/box/box_numb_' .. num1 .. '.png@105,76';
    pic = pic .. ';images/box/box_numb_' .. num2 .. '.png@152,76';
    pic = pic .. ';images/box/box_numb_' .. num3 .. '.png@198,76';
    
    if _('keyhole_1').key then
      pic = pic .. ';images/box/box_key_' .. _('keyhole_1').key.color .. '2.png@62,141';
    end;
    
    if _('keyhole_2').key then
      pic = pic .. ';images/box/box_key_' .. _('keyhole_2').key.color .. '2.png@112,141';
    end;
    
    if _('keyhole_3').key then
      pic = pic .. ';images/box/box_key_' .. _('keyhole_3').key.color .. '2.png@161,141';
    end;
    
    if _('keyhole_4').key then
      pic = pic .. ';images/box/box_key_' .. _('keyhole_4').key.color .. '2.png@212,141';
    end;
    
    return pic;
  end;
  sum = function(s)
    local sum = 0;
    
    if _('keyhole_1').key then
			sum = sum + _('keyhole_1').value * _('keyhole_1').key.value;
		end;

		if _('keyhole_2').key then
			sum = sum + _('keyhole_2').value * _('keyhole_2').key.value;
		end;

		if _('keyhole_3').key then
			sum = sum + _('keyhole_3').value * _('keyhole_3').key.value;
		end;

		if _('keyhole_4').key then
			sum = sum + _('keyhole_4').value * _('keyhole_4').key.value;
		end;
    
    return sum;
  end;
	value = function(s)
		local sum = s:sum();

		if sum < 10 then
			return '00' .. tostring(sum);
		elseif sum < 100 then
			return '0' .. tostring(sum);
		else
			return tostring(sum);
		end;
	end;
	test = function(s)
		return s:value() == level_1_target;
	end;
	decor = function(s)
		return translate_now("tower_locale", 'inside_box_decor', {
        numbers = s:value()
    });
	end;
	way = {
		path {translate("common_locale", 'back'), 'tower_level_1'};
	};
}:with {
	obj {
		nam = 'keyhole_1';
		value = 125;
		key = false;
		dsc = function(s)
			if s.key then
        return translate_now("tower_locale", 'inside_box_keyhole_1_key', {
            key = s.key.disp2
        }) .. '^';
			else
				return translate_now("tower_locale", 'inside_box_keyhole_1_empty') .. '^';
			end;
		end;
		used = function(s, o)
			if o^'tower_key_0' or o^'tower_key_1' or o^'tower_key_2' or o^'tower_key_3' then
        if s.key then
          return translate_now("tower_locale", 'inside_box_keyhole_used_has_key');
        end;
				s.key = o;
				remove(o, pl);

				pl:need_scene(true);
				p(translate_now("tower_locale", 'inside_box_keyhole_used_insert_key', {
              key = o.disp3
        }));

				if _('inside_box'):test() then
					remove('tower_box', pl);
					remove('tower_hint_1', pl);
					take('tower_level_2_key');
          p(translate_now("tower_locale", 'inside_box_keyhole_used_open'));
					walk('tower_level_1');
				end;
      else
        return false;
			end;
		end;
		act = function(s)
			pl:need_scene(true);
			if s.key then
				local key = s.key;
				take(key);
				s.key = false;
				return translate_now("tower_locale", 'inside_box_keyhole_act_key', {
            key = key.disp3
        });
			else
				return translate_now("tower_locale", 'inside_box_keyhole_act_empty');
			end;
		end;
	};
	obj {
		nam = 'keyhole_2';
		value = 25;
		key = false;
		dsc = function(s)
			if s.key then
        return translate_now("tower_locale", 'inside_box_keyhole_2_key', {
            key = s.key.disp2
        }) .. '^';
			else
				return translate_now("tower_locale", 'inside_box_keyhole_2_empty') .. '^';
			end;
		end;
		used = function(s, o)
			if o^'tower_key_0' or o^'tower_key_1' or o^'tower_key_2' or o^'tower_key_3' then
        if s.key then
          return translate_now("tower_locale", 'inside_box_keyhole_used_has_key');
        end;
        
				s.key = o;
				remove(o, pl);

				pl:need_scene(true);
				p(translate_now("tower_locale", 'inside_box_keyhole_used_insert_key', {
              key = o.disp3
        }));

				if _('inside_box'):test() then
					remove('tower_box', pl);
					remove('tower_hint_1', pl);
					take('tower_level_2_key');
					p(translate_now("tower_locale", 'inside_box_keyhole_used_open'));
					walk('tower_level_1');
				end;
      else
        return false;
			end;
		end;
		act = function(s)
			pl:need_scene(true);
			if s.key then
				local key = s.key;
				take(key);
				s.key = false;
				return translate_now("tower_locale", 'inside_box_keyhole_act_key', {
            key = key.disp3
        });
			else
				return translate_now("tower_locale", 'inside_box_keyhole_act_empty');
			end;
		end;
	};
	obj {
		nam = 'keyhole_3';
		value = 5;
		key = false;
		dsc = function(s)
			if s.key then
        return translate_now("tower_locale", 'inside_box_keyhole_3_key', {
            key = s.key.disp2
        }) .. '^';
			else
				return translate_now("tower_locale", 'inside_box_keyhole_3_empty') .. '^';
			end;
		end;
		used = function(s, o)
			if o^'tower_key_0' or o^'tower_key_1' or o^'tower_key_2' or o^'tower_key_3' then
        if s.key then
          return translate_now("tower_locale", 'inside_box_keyhole_used_has_key');
        end;
        
				s.key = o;
				remove(o, pl);

				pl:need_scene(true);
				p(translate_now("tower_locale", 'inside_box_keyhole_used_insert_key', {
              key = o.disp3
        }));

				if _('inside_box'):test() then
					remove('tower_box', pl);
					remove('tower_hint_1', pl);
					take('tower_level_2_key');
					p(translate_now("tower_locale", 'inside_box_keyhole_used_open'));
					walk('tower_level_1');
				end;
      else
        return false;
			end;
		end;
		act = function(s)
			pl:need_scene(true);
			if s.key then
				local key = s.key;
				take(key);
				s.key = false;
				return translate_now("tower_locale", 'inside_box_keyhole_act_key', {
            key = key.disp3
        });
			else
				return translate_now("tower_locale", 'inside_box_keyhole_act_empty');
			end;
		end;
	};
	obj {
		nam = 'keyhole_4';
		value = 1;
		key = false;
		dsc = function(s)
			if s.key then
        return translate_now("tower_locale", 'inside_box_keyhole_4_key', {
            key = s.key.disp2
        }) .. '^';
			else
				return translate_now("tower_locale", 'inside_box_keyhole_4_empty') .. '^';
			end;
		end;
		used = function(s, o)
			if o^'tower_key_0' or o^'tower_key_1' or o^'tower_key_2' or o^'tower_key_3' then
        if s.key then
          return translate_now("tower_locale", 'inside_box_keyhole_used_has_key');
        end;
				s.key = o;
				remove(o, pl);

				pl:need_scene(true);
				p(translate_now("tower_locale", 'inside_box_keyhole_used_insert_key', {
              key = o.disp3
        }));

				if _('inside_box'):test() then
					remove('tower_box', pl);
					remove('tower_hint_1', pl);
					take('tower_level_2_key');
					p(translate_now("tower_locale", 'inside_box_keyhole_used_open'));
					walk('tower_level_1');
				end;
        
      else
        return false;
			end;
		end;
		act = function(s)
			pl:need_scene(true);
			if s.key then
				local key = s.key;
				take(key);
				s.key = false;
				return translate_now("tower_locale", 'inside_box_keyhole_act_key', {
            key = key.disp3
        });
			else
				return translate_now("tower_locale", 'inside_box_keyhole_act_empty');
			end;
		end;
	};
}

room {
	nam = 'tower_level_2';
	pic = 'images/tower_level_2_l.png';
	disp = translate("tower_locale", 'tower_level_2_disp');
	theme = 'tower';
	decor = translate("tower_locale", 'tower_level_2_decor');
	way = {
		path {translate("tower_locale", 'transition_downstairs'), "tower_level_1"};
		path {"level_2_next_room", translate("tower_locale", 'transition_room'), "tower_level_2_room_2"}:disable();
		path {"level_2_up", translate("tower_locale", 'transition_upstairs'), "tower_level_3"}:disable();
	};
}:with {
	'tower_walls',
	obj {
		state = 0;
		nam = '#tables';
		act = function(s)
			p(translate_now("tower_locale", 'tower_level_2_tables'));
			if s.state == 0 then
				s.state = 1;
				_'red_catalyst':enable();
				_'purple_catalyst':enable();
				p(translate_now("tower_locale", 'tower_level_2_table_vials'));
			end;
		end;
	};
	obj {
		state = 0;
		nam = '#racks';
		act = function(s)
			p(translate_now("tower_locale", 'tower_level_2_racks'));
			if s.state == 0 then
				s.state = 1;
				_'blue_catalyst':enable();
				_'turquoise_catalyst':enable();
				p(translate_now("tower_locale", 'tower_level_2_rack_vials'));
			end;
		end;
	};
	obj {
		state = 0;
		nam = '#cabinets';
		act = function(s)
			p(translate_now("tower_locale", 'tower_level_2_cabinets'));
			if s.state == 0 then
				s.state = 1;
				_'green_catalyst':enable();
				_'yellow_catalyst':enable();
				p(translate_now("tower_locale", 'tower_level_2_cabinet_vials'));
			end;
		end;
	};
	obj {
		nam = '#fire';
		act = translate("tower_locale", 'tower_level_2_fire');
	};
	obj {
		nam = 'alchemy_book';
		dsc = translate("tower_locale", 'tower_level_2_book');
		act = function(s)
			walkin('alchemy_book_dlg');
		end;
	};
	obj {
		nam = 'tower_cauldron';
		act = function()
			walkin('cauldron_inside');
		end;
		used = function(s, o)
      if o^'kettle' or o^'cups' or o^'teapot' or o^'teabox' or o.ptype then
        return translate_now("tower_locale", 'tower_level_2_cannot_be_thrown')
      end;
      local cauldron = _('cauldron_inside');
      if cauldron.potion then
        return translate_now("tower_locale", 'tower_level_2_potion_in_the_cauldron')
      end;
			pl:need_scene(true);
			table.insert(cauldron.state, o);
			remove(o, pl);
			sounds['bubble']:play();
      p(translate_now("tower_locale", 'tower_level_2_cauldron_used', {
        item = o.disp3
      }));
			if cauldron:check_potion() then
				sounds['potion']:play();
				p(translate_now("tower_locale", 'tower_level_2_potion_ready'));
			end;
		end;
	};
	obj {
		state = false;
		nam = '#tower_2_door';
		dsc = function(s)
			if s.state then
				return translate_now("tower_locale", 'tower_2_door_dsc_open');
			else
				return translate_now("tower_locale", 'tower_2_door_dsc_closed');
			end;
		end;
		act = function(s)
			if s.state then
				return translate_now("tower_locale", 'tower_2_door_act_open');
			else
				return translate_now("tower_locale", 'tower_2_door_act_closed');
			end;
		end;
		used = function(s, o)
			if o^'hidden_key' then
				return translate_now("common_locale", 'key_does_not_fit');
			elseif o^'potion_open' then
				remove('potion_open', pl);
				s.state = true;
				enable('level_2_up');
				take('flask');
				return translate_now("tower_locale", 'tower_2_door_used_potion');
      else
        return false;
			end;
		end;
	}: with {
		obj {
			nam = '#stairwell';
			act = translate("tower_locale", 'tower_level_1_stairwell');
		}
	};
	obj {
		nam = 'red_catalyst';
		dsc = translate("tower_locale", 'red_catalyst_dsc');
		disp = translate("tower_locale", 'red_catalyst_disp');
		disp2 = translate("tower_locale", 'red_catalyst_disp2');
		disp3 = translate("tower_locale", 'red_catalyst_disp3');
		tak = translate("tower_locale", 'catalyst_tak');
		inv = translate("tower_locale", 'red_catalyst_inv');
	}:disable();
	obj {
		nam = 'green_catalyst';
		dsc = translate("tower_locale", 'green_catalyst_dsc');
		disp = translate("tower_locale", 'green_catalyst_disp');
		disp2 = translate("tower_locale", 'green_catalyst_disp2');
		disp3 = translate("tower_locale", 'green_catalyst_disp3');
		tak = translate("tower_locale", 'catalyst_tak');
		inv = translate("tower_locale", 'green_catalyst_inv');
	}:disable();
	obj {
		nam = 'blue_catalyst';
		dsc = translate("tower_locale", 'blue_catalyst_dsc');
		disp = translate("tower_locale", 'blue_catalyst_disp');
		disp2 = translate("tower_locale", 'blue_catalyst_disp2');
		disp3 = translate("tower_locale", 'blue_catalyst_disp3');
		tak = translate("tower_locale", 'catalyst_tak');
		inv = translate("tower_locale", 'blue_catalyst_inv');
	}:disable();
  obj {
		nam = 'purple_catalyst';
		dsc = translate("tower_locale", 'purple_catalyst_dsc');
		disp = translate("tower_locale", 'purple_catalyst_disp');
		disp2 = translate("tower_locale", 'purple_catalyst_disp2');
		disp3 = translate("tower_locale", 'purple_catalyst_disp3');
		tak = translate("tower_locale", 'catalyst_tak');
		inv = translate("tower_locale", 'purple_catalyst_inv');
	}:disable();
	obj {
		nam = 'yellow_catalyst';
		dsc = translate("tower_locale", 'yellow_catalyst_dsc');
		disp = translate("tower_locale", 'yellow_catalyst_disp');
		disp2 = translate("tower_locale", 'yellow_catalyst_disp2');
		disp3 = translate("tower_locale", 'yellow_catalyst_disp3');
		tak = translate("tower_locale", 'catalyst_tak');
		inv = translate("tower_locale", 'yellow_catalyst_inv');
	}:disable();
	obj {
		nam = 'turquoise_catalyst';
		dsc = translate("tower_locale", 'turquoise_catalyst_dsc');
		disp = translate("tower_locale", 'turquoise_catalyst_disp');
		disp2 = translate("tower_locale", 'turquoise_catalyst_disp2');
		disp3 = translate("tower_locale", 'turquoise_catalyst_disp3');
		tak = translate("tower_locale", 'catalyst_tak');
		inv = translate("tower_locale", 'turquoise_catalyst_inv');
	}:disable();
}

dlg {
	nam = 'alchemy_book_dlg';
  theme = 'tower';
	pic = 'images/tower_level_2_l.png';
	disp = translate("tower_locale", 'alchemy_book_dlg_disp');
	enter = translate("tower_locale", 'alchemy_book_dlg_enter');
	phr = {
    {always=true, translate("tower_locale", 'alchemy_book_dlg_open'), function(s)
        return translate_now("tower_locale", 'alchemy_book_dlg_open_response', {catalyst=_(opening_catalyst).disp2});
    end};
		{always=true, translate("tower_locale", 'alchemy_book_dlg_light'), function(s)
        return translate_now("tower_locale", 'alchemy_book_dlg_light_response', {catalyst=_(light_catalyst).disp2});
    end};
		{always=true, translate("tower_locale", 'alchemy_book_dlg_rich'), function(s)
        return translate_now("tower_locale", 'alchemy_book_dlg_rich_response', {catalyst=_(enrichment_catalyst).disp2});
    end};
		{always=true, translate("tower_locale", 'alchemy_book_dlg_leave'), function() walkout(); end}
	};
}

dlg {
  theme = 'tower';
	state = {};
	potion = false;
	hideinv = true;
	nam = 'cauldron_inside';
	pic = 'images/tower_level_2_l.png';
	disp = translate("tower_locale", 'cauldron_inside_disp');
	check_potion = function(s)
		if #s.state == 3 then
			if has_object(s.state, 'lock') and has_object(s.state, 'hidden_key') and has_object(s.state, opening_catalyst) then
				s.potion = _('potion_open');
				return true;
			elseif has_object(s.state, 'candle') and has_object(s.state, 'flask') and has_object(s.state, light_catalyst) then
				s.potion = _('potion_light');
				return true;
			elseif has_object(s.state, 'silver_fork') and has_object(s.state, 'emerald') and has_object(s.state, enrichment_catalyst) then
				s.potion = _('potion_enrichment');
				return true;
			end;
		end;

		return false;
	end;
	enter = function(s)
		if s.potion then
			enable('#take_potion');
			disable('#take_all');
      return translate_now("tower_locale", 'cauldron_inside_enter_potion', {
          potion=std.call(s.potion, "disp2");
      });
		elseif #s.state == 0 then
			disable('#take_potion');
			disable('#take_all');
			return translate_now("tower_locale", 'cauldron_inside_enter_water');
		elseif #s.state == 1 then
			disable('#take_potion');
			enable('#take_all');
      return translate_now("tower_locale", 'cauldron_inside_enter_single_item', {
          item=std.call(s.state[1], "disp2");
      });
		else
			disable('#take_potion');
			enable('#take_all');

			local dsc = translate_now("tower_locale", 'cauldron_inside_enter_many_items') .. ' ';

			for i = 1, #s.state do
				dsc = dsc .. std.call(s.state[i], "disp2");
				if i < #s.state then
					dsc = dsc .. ', ';
				end;
			end;
			return dsc .. '. ';
		end;
	end;
	phr = {
		{'#take_potion', translate("tower_locale", 'cauldron_inside_take_potion'), function(s)
			local potion = _('cauldron_inside').potion;
			_('cauldron_inside').state = {};
			take(potion);
			_('cauldron_inside').potion = false;
			pr(translate_now("tower_locale", 'cauldron_inside_take_potion_response'));
			walkout();
		end};
		{'#take_all', translate("tower_locale", 'cauldron_inside_take_items'), function(s)
			local state = _('cauldron_inside').state;
			_('cauldron_inside').state = {};
			for i = 1, #state do
				take(state[i]);
			end;
			walkout();
		end};
		{always=true, translate("tower_locale", 'cauldron_inside_leave'), function(s)
			walkout();
		end;};
	}
}

room {
	nam = 'tower_level_3';
	theme = 'tower';
	disp = translate("tower_locale", 'tower_level_3_disp');
	pic = 'images/tower_level_3.png';
	decor = translate("tower_locale", 'tower_level_3_decor');
  enter = function(s)
    if tower_accept_level < 1 then
      tower_accept_level = 1;
    end;
  end;
	way = {
		path {translate("tower_locale", 'transition_downstairs'), "tower_level_2"};
		path {"level_3_next_room", translate("tower_locale", 'transition_room'), "tower_level_3_room_2"}:disable();
		path {"level_3_up", translate("tower_locale", 'transition_upstairs'), "tower_level_4"}:disable();
	};
}:with {
  'tower_walls',
	obj {
		nam = '#bookshelves';
		act = translate("tower_locale", 'tower_level_3_bookshelves');
	};
	obj {
		nam = '#fireplace';
		act = translate("tower_locale", 'tower_level_3_fireplace');
	};
	obj {
		nam = '#rockchair';
		act = translate("tower_locale", 'tower_level_3_rockchair');
	};
	obj {
		nam = 'level_3_room_2_door';
		dsc = translate("tower_locale", 'tower_level_3_hidden_door_dsc');
		act = translate("tower_locale", 'tower_level_3_hidden_door_act');
	}:disable();
	obj {
		solved = false;
		nam = 'tower_level_3_table';
		act = function(s)
			if s.solved then
				return translate_now("tower_locale", 'tower_level_3_table_decor') .. ' ' .. translate_now("tower_locale", 'tower_level_3_table_decor_solved');
			else
				walkin('tower_level_3_table_in');
			end;
		end;
	};
	obj {
		nam = '#tower_3_door';
		dsc = function(s)
			if _'level_3_up':disabled() then
				return translate_now("tower_locale", 'tower_level_3_door_dsc_locked');
			else
				return translate_now("tower_locale", 'tower_level_3_door_dsc_open');
			end;
		end;
		act = function(s)
			if _'level_3_up':disabled() then
				return translate_now("tower_locale", 'tower_level_3_door_act_locked');
			else
				return translate_now("tower_locale", 'tower_level_3_door_act_open');
			end;
		end;
	}: with {
		obj {
			nam = '#stairwell';
			act = translate("tower_locale", 'tower_level_1_stairwell');
		}
	};
}

room {
	nam = 'tower_level_3_table_in';
  pic = function(s)
    local p = 'images/table/table_reff.png';
    if _'#figures':disabled() then
      p = 'images/table/table_base.png';
    end;
    
    local nw = _'#north_west';
    local ne = _'#north_east';
    local sw = _'#south_west';
    local se = _'#south_east';
    local cc = _'#middle';
    
    local pic_by_name = function (name)
      if name == 'figure_wolf' then
        return 'images/table/table_wolf.png', 0, 0;
      elseif name == 'figure_tiger' then
        return 'images/table/table_tiger.png', 0, -14;
      elseif name == 'figure_lion' then
        return 'images/table/table_lion.png', -3, -6;
      elseif name == 'figure_knight' then
        return 'images/table/table_knight.png', 0, 0;
      elseif name == 'figure_tower' then
        return 'images/table/table_tower.png', 0, -14;
      end;
    end;
    
    if nw.item then
      local n, dx, dy = pic_by_name(nw.item.nam);
      p = p .. ';' .. n .. '@' .. tostring(25 + dx) .. ',' .. tostring(33 + dy);
    end;
    
    if ne.item then
      local n, dx, dy = pic_by_name(ne.item.nam);
      p = p .. ';' .. n .. '@' .. tostring(258 + dx) .. ',' .. tostring(33 + dy);
    end;
    
    if sw.item then
      local n, dx, dy = pic_by_name(sw.item.nam);
      p = p .. ';' .. n .. '@' .. tostring(25 + dx) .. ',' .. tostring(172 + dy);
    end;
    
    if se.item then
      local n, dx, dy = pic_by_name(se.item.nam);
      p = p .. ';' .. n .. '@' .. tostring(258 + dx) .. ',' .. tostring(172 + dy);
    end;
    
    if cc.item then
      local n, dx, dy = pic_by_name(cc.item.nam);
      p = p .. ';' .. n .. '@' .. tostring(140 + dx) .. ',' .. tostring(96 + dy);
    end;
    
    return p;
  end;
	theme = 'tower';
	nofollow = true;
	disp = translate("tower_locale", 'tower_level_3_disp');
	decor = function(s)
    return translate_now("tower_locale", 'tower_level_3_table_decor') .. ' ' .. translate_now("tower_locale", 'tower_level_3_table_decor_unsolved');
  end;
	way = {
		path {translate("common_locale", 'back'), 'tower_level_3'};
	};
}:with {
	obj {
		nam = '#figures';
		dsc = translate("tower_locale", 'tower_level_3_table_in_figures_dsc');
		act = function(s)
			take('figure_wolf');
			take('figure_tiger');
			take('figure_lion');
			take('figure_knight');
			take('figure_tower');
			s:disable();
			return translate_now("tower_locale", 'tower_level_3_table_in_figures_act');
		end;
	};
	obj {
		item = false;
		target = 'figure_wolf';
		nam = '#north_west';
		dsc = function(s)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_full', {
            location='NW',
            item=s.item.disp2
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_empty', {
            location='NW'
        });
			end;
		end;
		act = function(s)
			if s.item then
				local t = s.item;
				take(s.item);
				s.item = false;
        return translate_now("tower_locale", 'tower_level_3_table_deepening_act_full', {
            item=t.disp3
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_act_empty');
			end;
		end;
		used = function(s, o)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_used_full', {
            item=s.item.disp2
        });
			elseif o^'figure_wolf' or o^'figure_lion' or o^'figure_tower' or o^'figure_knight' or o^'figure_tiger' then
				s.item = o;
        p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_fit', {
            item=o.disp3
        }));
				remove(o, pl);
				local niches = {
					_('#north_west');
					_('#north_east');
					_('#middle');
					_('#south_west');
					_('#south_east');
				};

				for i = 1, #niches do
					if not niches[i].item or niches[i].item.nam ~= niches[i].target then
						return;
					end;
				end;

				_('tower_level_3_table').solved = true;
				walkout();
				_('level_3_up'):enable();
				p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_open'));
      else
        return false;
			end;
		end;
	};
	obj {
		item = false;
		target = 'figure_lion';
		nam = '#north_east';
		dsc = function(s)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_full', {
            location='NE',
            item=s.item.disp2
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_empty', {
            location='NE'
        });
			end;
		end;
		act = function(s)
			if s.item then
				local t = s.item;
				take(s.item);
				s.item = false;
        return translate_now("tower_locale", 'tower_level_3_table_deepening_act_full', {
            item=t.disp3
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_act_empty');
			end;
		end;
		used = function(s, o)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_used_full', {
            item=s.item.disp2
        });
			elseif o^'figure_wolf' or o^'figure_lion' or o^'figure_tower' or o^'figure_knight' or o^'figure_tiger' then
				s.item = o;
        p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_fit', {
            item=o.disp3
        }));
				remove(o, pl);
				local niches = {
					_('#north_west');
					_('#north_east');
					_('#middle');
					_('#south_west');
					_('#south_east');
				};

				for i = 1, #niches do
					if not niches[i].item or niches[i].item.nam ~= niches[i].target then
						return;
					end;
				end;

				_('tower_level_3_table').solved = true;
				walkout();
				_('level_3_up'):enable();
				p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_open'));
      else
        return false;
			end;
		end;
	};
	obj {
		item = false;
		target = 'figure_tower';
		nam = '#middle';
		dsc = function(s)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_middle_deepening_dsc_full', {
            item=s.item.disp2
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_middle_deepening_dsc_empty');
			end;
		end;
		act = function(s)
			if s.item then
				local t = s.item;
				take(s.item);
				s.item = false;
        return translate_now("tower_locale", 'tower_level_3_table_deepening_act_full', {
            item=t.disp3
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_act_empty');
			end;
		end;
		used = function(s, o)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_used_full', {
            item=s.item.disp2
        });
			elseif o^'figure_wolf' or o^'figure_lion' or o^'figure_tower' or o^'figure_knight' or o^'figure_tiger' then
				s.item = o;
        p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_fit', {
            item=o.disp3
        }));
				remove(o, pl);
				local niches = {
					_('#north_west');
					_('#north_east');
					_('#middle');
					_('#south_west');
					_('#south_east');
				};

				for i = 1, #niches do
					if not niches[i].item or niches[i].item.nam ~= niches[i].target then
						return;
					end;
				end;

				_('tower_level_3_table').solved = true;
				walkout();
				_('level_3_up'):enable();
				p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_open'));
      else
        return false;
			end;
		end;
	};
	obj {
		item = false;
		target = 'figure_knight';
		nam = '#south_west';
		dsc = function(s)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_full', {
            location='SW',
            item=s.item.disp2
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_empty', {
            location='SW'
        });
			end;
		end;
		act = function(s)
			if s.item then
				local t = s.item;
				take(s.item);
				s.item = false;
        return translate_now("tower_locale", 'tower_level_3_table_deepening_act_full', {
            item=t.disp3
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_act_empty');
			end;
		end;
		used = function(s, o)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_used_full', {
            item=s.item.disp2
        });
			elseif o^'figure_wolf' or o^'figure_lion' or o^'figure_tower' or o^'figure_knight' or o^'figure_tiger' then
				s.item = o;
        p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_fit', {
            item=o.disp3
        }));
				remove(o, pl);
				local niches = {
					_('#north_west');
					_('#north_east');
					_('#middle');
					_('#south_west');
					_('#south_east');
				};

				for i = 1, #niches do
					if not niches[i].item or niches[i].item.nam ~= niches[i].target then
						return;
					end;
				end;

				_('tower_level_3_table').solved = true;
				walkout();
				_('level_3_up'):enable();
				p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_open'));
      else
        return false;
			end;
		end;
	};
	obj {
		item = false;
		target = 'figure_tiger';
		nam = '#south_east';
		dsc = function(s)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_full', {
            location='SE',
            item=s.item.disp2
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_dsc_empty', {
            location='SE'
        });
			end;
		end;
		act = function(s)
			if s.item then
				local t = s.item;
				take(s.item);
				s.item = false;
        return translate_now("tower_locale", 'tower_level_3_table_deepening_act_full', {
            item=t.disp3
        });
			else
				return translate_now("tower_locale", 'tower_level_3_table_deepening_act_empty');
			end;
		end;
		used = function(s, o)
			if s.item then
        return translate_now("tower_locale", 'tower_level_3_table_deepening_used_full', {
            item=s.item.disp2
        });
			elseif o^'figure_wolf' or o^'figure_lion' or o^'figure_tower' or o^'figure_knight' or o^'figure_tiger' then
				s.item = o;
        p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_fit', {
            item=o.disp3
        }));
				remove(o, pl);
				local niches = {
					_('#north_west');
					_('#north_east');
					_('#middle');
					_('#south_west');
					_('#south_east');
				};

				for i = 1, #niches do
					if not niches[i].item or niches[i].item.nam ~= niches[i].target then
						return;
					end;
				end;

				_('tower_level_3_table').solved = true;
				walkout();
				_('level_3_up'):enable();
				p(translate_now("tower_locale", 'tower_level_3_table_deepening_used_open'));
      else
        return false;
			end;
		end;
	};
	obj {
		nam = '#hint';
		act = translate("tower_locale", 'tower_level_3_hint');
	}
}

obj {
	nam = 'figure_wolf';
	disp = translate("tower_locale", 'figure_wolf_disp');
	disp2 = translate("tower_locale", 'figure_wolf_disp2');
	disp3 = translate("tower_locale", 'figure_wolf_disp3');
	inv = function(s)
    return translate_now("tower_locale", 'figure_wolf_inv') .. ' ' .. translate_now("tower_locale", 'figure_common_inv');
  end;
}

obj {
	nam = 'figure_tiger';
	disp = translate("tower_locale", 'figure_tiger_disp');
	disp2 = translate("tower_locale", 'figure_tiger_disp2');
	disp3 = translate("tower_locale", 'figure_tiger_disp3');
	inv = function(s)
    return translate_now("tower_locale", 'figure_tiger_inv') .. ' ' .. translate_now("tower_locale", 'figure_common_inv');
  end;
}

obj {
	nam = 'figure_lion';
  disp = translate("tower_locale", 'figure_lion_disp');
	disp2 = translate("tower_locale", 'figure_lion_disp2');
	disp3 = translate("tower_locale", 'figure_lion_disp3');
  inv = function(s)
    return translate_now("tower_locale", 'figure_lion_inv') .. ' ' .. translate_now("tower_locale", 'figure_common_inv');
  end;
}

obj {
	nam = 'figure_knight';
  disp = translate("tower_locale", 'figure_knight_disp');
	disp2 = translate("tower_locale", 'figure_knight_disp2');
	disp3 = translate("tower_locale", 'figure_knight_disp3');
  inv = function(s)
    return translate_now("tower_locale", 'figure_knight_inv') .. ' ' .. translate_now("tower_locale", 'figure_common_inv');
  end;
}

obj {
	nam = 'figure_tower';
  disp = translate("tower_locale", 'figure_tower_disp');
	disp2 = translate("tower_locale", 'figure_tower_disp2');
	disp3 = translate("tower_locale", 'figure_tower_disp3');
  inv = function(s)
    return translate_now("tower_locale", 'figure_tower_inv') .. ' ' .. translate_now("tower_locale", 'figure_common_inv');
  end;
}

room {
	nam = 'tower_level_4';
	theme = 'tower';
	disp = translate("tower_locale", 'tower_level_4_disp');
	pic = 'images/tower_level_4.png';
	decor = translate("tower_locale", 'tower_level_4_decor');
  enter = function(s)
    if tower_accept_level < 2 then
      tower_accept_level = 2;
    end;
    
    snd.music('sound/bgm_tower.ogg');
  end;
	way = {
		path {translate("tower_locale", 'transition_downstairs'), "tower_level_3"};
		path {"level_4_next_room", translate("tower_locale", 'transition_room'), "tower_level_4_room_2"}:disable();
	};
}: with {
	'tower_walls',
	obj {
		nam = '#bed';
		act = translate("tower_locale", 'tower_level_4_bed');
	};
	obj {
		nam = '#table';
		act = translate("tower_locale", 'tower_level_4_table');
	};
	obj {
		nam = '#candelabra';
		state = 0;
		act = function(s)
			if candles_solved then
				if not candle_taken then
					s.state = 1;
					take('candle');
					candle_taken = true;
					return translate_now("tower_locale", 'tower_candelabra_candle_taken');
				else
					if s.state == 0 then
						return translate_now("tower_locale", 'tower_level_4_chandelier_act');
					else
						return translate_now("tower_locale", 'tower_level_4_chandelier_act') .. ' ' .. translate_now("tower_locale", 'tower_candelabra_candle_missing');
					end;
				end;
			else
				walkin('tower_candelabra');
			end;
		end;
	};
	obj {
		nam = '#tower_4_door';
		dsc = function(s)
			if _'level_4_next_room':disabled() then
        return translate_now("tower_locale", 'tower_level_4_door_dsc_locked');
			else
        return translate_now("tower_locale", 'tower_level_4_door_dsc_open');
			end;
		end;
		act = function(s)
			if _'level_4_next_room':disabled() then
        return translate_now("tower_locale", 'tower_level_4_door_act_locked');
			else
        return translate_now("tower_locale", 'tower_level_4_door_act_open');
			end;
		end;
	};
}

local candles_offsets = {
	{28, 35, 35, 40, -2, -5, 36, 105, -1, -70},
	{28, 36, 35, 42, -2, -6, 36, 117, -1, -81},
	{28, 36, 34, 44, -2, -5, 36, 128, -1, -92},
	{28, 39, 30, 42, -2, -3, 36,  69, -1, -30},
	{28, 36, 30, 39, -2, -3, 36, 128, -1, -92},
	{28, 36, 30, 39, -2, -3, 36, 117, -1, -81},
	{28, 35, 30, 38, -2, -3, 36, 127, -1, -70}
}

function candle(title, note, index, note_name, dx, dy)
	return obj {
		nam = 'candle_' .. note;
		dsc = function(s)
      return '{' .. translate_now("tower_locale", title) .. '}^';
    end;
		lit = false;
    restore = function(s) 
      if s.lit then
        local px = tonumber(theme.get('scr.gfx.x')) / diretheme.get_scale();
        local py = tonumber(theme.get('scr.gfx.y')) / diretheme.get_scale();
        
        DSA {
				'candle_' .. tostring(index) .. '_fire', 
				'img',
				'images/candles/' .. tostring(index) .. '/candles_flame_start.png', 
				h = candles_offsets[index][2], 
				w = candles_offsets[index][1], 
				frames=6,
				animated=true,
				x = px + dx,
				y = py + dy,
				z = -1,
				delay=50,
				process=function(v)
					if v.frame_nr == 5 then
						DSA {
							'candle_' .. tostring(index) .. '_fire', 
							'img',
							'images/candles/' .. tostring(index) .. '/candles_flame.png', 
							h = candles_offsets[index][4],
							w = candles_offsets[index][3],
							frames=6,
							animated=true,
							x = px + dx + candles_offsets[index][5],
							y = py + dy + candles_offsets[index][6],
							z = -1,
							delay=50,
						}
          else
            return true;
					end;
				end;
			};
      end;
    end;
		act = function(s)
      stop_sound();
			sounds[note_name]:play();
      p(translate_now("tower_locale", 'tower_level_4_candle_act_lit', {
          note=translate_now("note_locale", note_name)
      }));
			s.lit = true;
			
      s:restore();
			s:disable();

			if here().notestack[here().playindex] ~= index then
				_('tower_candelabra').timerstate = 1;
				here().playindex = 1;

				_'candle_c':blow();
				_'candle_d':blow();
				_'candle_e':blow();
				_'candle_f':blow();
				_'candle_g':blow();
				_'candle_a':blow();
				_'candle_b':blow();

        pn(translate_now("tower_locale", 'tower_level_4_candle_act_blow'));

				local candelabra = _'tower_candelabra';

        p(translate_now("tower_locale", 'tower_level_4_candle_act_sequence'));
				for i = 1, 6 do
					pr(translate_now("note_locale", candelabra.notesequence[i]) .. ', ');
				end;

				pr(translate_now("note_locale", candelabra.notesequence[7]) .. '. ');
			else
				here().playindex = here().playindex + 1;
				if here().playindex > 7 then
					candles_solved = true;
					_('level_4_next_room'):enable();
					_('tower_candelabra').timerstate = 4;

          p(translate_now("tower_locale", 'tower_level_4_candle_act_open'));

					local ns = {
						gusts[rnd(#gusts)];
						'open_door';
					};
					stop_sound();
					play_sound(ns, 600);

					walk('tower_level_4');
				end;
			end;
		end;
		blow = function(s)
			s:enable();
			if s.lit then
				local px = tonumber(theme.get('scr.gfx.x')) / diretheme.get_scale();
				local py = tonumber(theme.get('scr.gfx.y')) / diretheme.get_scale();
				
				DSA {
					'candle_' .. tostring(index) .. '_fire', 
					'img',
					'images/candles/' .. tostring(index) .. '/candles_blow_out_short.png', 
					h = candles_offsets[index][8], 
					w = candles_offsets[index][7], 
					frames=15,
					animated=true,
					x = px + dx + candles_offsets[index][9],
					y = py + dy + candles_offsets[index][10],
					z = -1,
					delay=50,
					process=function(v)
						if v.frame_nr == 14 then
							D {'candle_' .. tostring(index) .. '_fire'};
						end;
					end;
				};
			end;
			s.lit = false;
		end;
	};
end;

room {
  notes = {
		'note_c',
		'note_d',
		'note_e',
		'note_f',
		'note_g',
		'note_a',
		'note_b',
	};
	text = '';
	notestack = {};
	notesequence = {};
	playindex = 1;
	timerstate = 3;
	nam = 'tower_candelabra';
	disp = translate("tower_locale", 'tower_level_4_disp');
	theme = 'tower';
	nofollow = true;
	dsc = translate("tower_locale", 'tower_candelabra_dsc');
	pic = 'images/candles/candles_all_kinds_bg.png';
	timer = function(s)
		if s.timerstate == 1 then
			s.timerstate = 6;
			sounds[gusts[rnd(#gusts)]]:play();
		elseif s.timerstate == 2 then
			s.timerstate = 3;
			stop_sound();
			play_sound(s.notesequence, 600, false);
		elseif s.timerstate == 4 then
			s.timerstate = 5;
			sounds[gusts[rnd(#gusts)]]:play();
		elseif s.timerstate == 5 then
			s.timerstate = 3;
			sounds['open_door']:play();
		elseif s.timerstate == 3 then
		elseif s.timerstate < 66 then
			s.timerstate = s.timerstate + 1;
		else 
			s.timerstate = 2
		end;

		return false;
	end;
  initnotes = function(s)
    if #s.notestack == 0 then
			local ns = {1,2,3,4,5,6,7};

			for i = 1, 7 do
				local idx = rnd(#ns);
				table.insert(s.notestack, ns[idx]);
				table.insert(s.notesequence, s.notes[ns[idx]]);
				ns[idx] = ns[8 - i];
				ns[8 - i] = nil;
			end;
		end;

  end;
	enter = function(s)
    snd.music('sound/amb_tower.ogg');
		s:initnotes();
    
		if #s.notesequence == 0 then
			s.notesequence = {false, false, false};
			for i = 1, 7 do
				table.insert(s.notesequence, s.notes[s.notestack[i]][2]);
			end;
		end;
		stop_sound();
		play_sound(table.copy(s.notesequence), 600);

    p(translate_now("tower_locale", 'tower_candelabra_enter'));
		for i = 1, 6 do
      pr(translate_now("note_locale", s.notesequence[i]) .. ', ');
    end;

    pr(translate_now("note_locale", s.notesequence[7]) .. '. ');
	end;
	obj = {
		candle('tower_candle_1', 'c', 1, 'note_c', 57, 70);
		candle('tower_candle_2', 'd', 2, 'note_d', 83, 81);
		candle('tower_candle_3', 'e', 3, 'note_e', 106, 92);
		candle('tower_candle_4', 'f', 4, 'note_f', 143, 30);
		candle('tower_candle_5', 'g', 5, 'note_g', 176, 92);
		candle('tower_candle_6', 'a', 6, 'note_a', 201, 81);
		candle('tower_candle_7', 'b', 7, 'note_b', 226, 70);
	};
	way = {
		path {translate("common_locale", 'back'), 'tower_level_4'};
	};
  themeInit = function(s)
    timer:set(25);
    
    for i, candle in ipairs(s.obj) do
      candle:restore();
    end;
  end;
	themeDispose = function(s)
		D {'candle_1_fire'};
		D {'candle_2_fire'};
		D {'candle_3_fire'};
		D {'candle_4_fire'};
		D {'candle_5_fire'};
		D {'candle_6_fire'};
		D {'candle_7_fire'};
	end;
}

room {
	nam = 'tower_level_4_room_2';
	disp = translate("tower_locale", 'tower_level_4_room_2_disp');
	theme = 'tower';
	pic = function(s)
		if power_on then
			return 'images/tower_level_4_room_2_light.png';
		else
			return 'images/tower_level_4_room_2_dark.png';
		end;
	end;
  enter = function(s)
    instead.autosave();
  end;
	decor = translate("tower_locale", 'tower_level_4_room_2_decor');
	way = {
		path { translate("tower_locale", 'transition_door'), 'tower_level_4' };
		path { translate("tower_locale", 'transition_downstairs'), 'tower_level_3_room_2' };
	};
}: with {
	obj {
		nam = '#ladder';
		act = translate("tower_locale", 'tower_level_4_room_2_ladder');
	};
	obj {
		nam = '#servers';
		act = function(s)
			if power_on then
				return translate_now("tower_locale", 'tower_level_4_room_2_servers_powered');
			else
				return translate_now("tower_locale", 'tower_level_4_room_2_servers');
			end;
		end;
	};
	obj {
		nam = '#table';
		act = translate("tower_locale", 'tower_level_4_room_2_table');
	};
	obj {
		nam = '#armchair';
		act = translate("tower_locale", 'tower_level_4_room_2_armchair');
	};
	obj {
		assembled = true;
		nam = '#computer';
		act = function(s)
			if s.assembled then
				if power_on then
					return _('system_unit'):check();
				else
					return translate_now("tower_locale", 'tower_level_4_room_2_computer_act');
				end;
			else
				walkin('system_unit');
			end;
		end;
		used = function(s, o)
			if o^'tool_box' then
				s.assembled = not s.assembled;
        
        if s.assembled then
          return translate_now("tower_locale", 'tower_level_4_room_2_computer_used_assemble');
        else
          return translate_now("tower_locale", 'tower_level_4_room_2_computer_used_disassemble');
        end;
			end;
      
      return false;
		end;
	};
	obj {
		nam = '#monitor';
		act = translate("tower_locale", 'tower_level_4_room_2_monitor');
	};
	obj {
		nam = '#manual';
		act = function(s)
			walkin('terminal_manual');
		end;
	};
}

declare {
	sound_index = 1;
	sound_data = {};
	sound_speed = 600;
	sound_last = 0;
  
  animation_index = 1;
  animation_data = false;
  animation_next = 0;
  animation_counter = 0;
}

function animation_tick()
  if not animation_data or #animation_data == 0 then
    return;
  end;
  
  if animation_next == 0 then
    animation_next = instead.ticks();
  elseif animation_next == false then
    -- Do Nothing
  else
    while animation_next ~= false and animation_next <= instead.ticks() do
      local animation_item = animation_data[animation_index];
      
      if not animation_item then
        -- Animation is over
        animation_data = false;
        return;
      end;
      
      if animation_item.type == 'delay' then
        animation_next = animation_next + animation_item.delay;
      elseif animation_item.type == 'image' then
        local image;
        if animation_item.image then
          if type(animation_item.image) == 'userdata' then
            image = animation_item.image
          else
            image = get_sprite(animation_item.image);
          end;
        end;
        D {
          'anim_root',
          'img',
          image,
          x = animation_item.x,
          y = animation_item.y,
          w = animation_item.w,
          h = animation_item.h,
          alpha = animation_item.alpha,
          delay = animation_item.delay,
          process = animation_item.process,
          background = animation_item.background,
          z = 2,
        };
        animation_next = animation_next + (animation_item.delay or 0);
      elseif animation_item.type == 'anim' then
        local image;
        if animation_item.image then
          if type(animation_item.image) == 'userdata' then
            image = animation_item.image
          else
            image = get_sprite(animation_item.image);
          end;
        end;
        local rpt = 1;
        if animation_item.loop then
          rpt = animation_item.loop;
        end;
        local frame_data = nil;
        if animation_item.frame_data then
          frame_data = scale_frame_data(animation_item.frame_data)
        end;
        D {
          'anim_frames',
          'img',
          image,
          x = animation_item.x,
          y = animation_item.y,
          w = animation_item.w,
          h = animation_item.h,
          frames = animation_item.frames,
          animated = true,
          speed = animation_item.speed,
          delay = animation_item.delay,
          frame_data = frame_data,
          background = animation_item.background,
          process = function (v)
            if v.frame_nr == animation_item.frames - 1 then
              if animation_counter == 0 then
                v.animated = false;
                local delay = animation_item.delay;
                if type(delay) == 'table' then
                  delay = delay[#delay];
                end;
                animation_next = instead.ticks() + delay;
                v.process = nil;
              else
                animation_counter = animation_counter - 1;
              end;
            end;
          end;
          z = 1;
        };
        
        animation_next = false;
        animation_counter = rpt - 1;
      elseif animation_item.type == 'reset' then
        animation_index = animation_item.index - 1;
        animation_next = instead.ticks();
      end;
      
      animation_index = animation_index + 1;
    end;
  end;
end;

function animation_set(animation, sync)
  --[[
  {type="wait", delay: ms} -- wait for `delay` ms, doing nothing
  {type="image", image, x, y, w, h, delay} -- paint `image`, wait for `delay` ms
  {type="anim", image, x, y, w, h, frames, delay} -- show animation with `delay` ms between frames
  {type="anim", image, x, y, w, h, frames, delay, loop} -- show animation with `delay` ms between frames, repeat it `repeat` times
  {type="reset", reset: int} -- reset the animation from `reset` item to run it again
  ]]
  if instead.tiny then
    return;
  end;
  animation_data = animation;
  animation_index = 1;
  if sync then
    animation_next = 0;
  else
    animation_next = instead.ticks();
  end;
  D {'anim_root'};
  D {'anim_frames'};
end;

function sound_tick()
  if #sound_data > 0 then
		if sound_last + sound_speed <= instead.ticks() then
			sound_last = instead.ticks();
			if sound_index > #sound_data then
				sound_data = {};
				return false;
			end;

			if sound_data[sound_index] then
				sounds[sound_data[sound_index]]:play();
			end;

			sound_index = sound_index + 1;
		end;
	end;
end;

function play_sound(data, speed, immediate)
  timer:set(25);
	sound_index = 1;
	sound_data = data;
	sound_speed = speed;
	if #sound_data > 0 then
		sound_last = instead.ticks();
		if immediate then
			if sound_data[sound_index] then
				sounds[sound_data[sound_index]]:play();
			end;
			sound_index = sound_index + 1;
		end;
	end;
end;

function stop_sound()
	sound_data = {};
	sound_index = 1;
end;

function game:timer()
	sound_tick();
  animation_tick();
	return false;
end;

room {
	{
		data = false;
		sound_index = 1;
	};
	pic = function(s)
		local pic = 'images/terminal_parts/pc_base.png';
    
    local motherboard = lookup('#motherboard', _'system_unit');
		local cpu = lookup('#cpu', _'system_unit');
		local ram = lookup('#ram', _'system_unit');
		local slot1 = lookup('#slot1', _'system_unit');
		local slot2 = lookup('#slot2', _'system_unit');
		local slot3 = lookup('#slot3', _'system_unit');
		local slot4 = lookup('#slot4', _'system_unit');
		local slots = {slot1, slot2, slot3, slot4};
    
    if motherboard.device then
      pic = pic .. ';images/terminal_parts/motherboard' .. tostring(motherboard.device.slots) .. '.png@26,4'
      pic = pic .. ';images/terminal_parts/socket_' .. motherboard.device.cpu:lower() .. '.png@220,47';
    end;
    if cpu.device then
      pic = pic .. ';images/terminal_parts/cpu_' .. cpu.device.slot:lower() .. '.png@219,46';
    end;
    
    if ram.device then
      local ram_type;
      if ram.device.slot == 'RKT' then
        if ram.device.size < 4 then
          ram_type = 1;
        else
          ram_type = 2;
        end;
      elseif ram.device.slot == 'RST' then
        if ram.device.size < 16 then
          ram_type = 2;
        else
          ram_type = 3;
        end;
      elseif ram.device.slot == 'RDT' then
        if ram.device.size < 64 then
          ram_type = 3;
        else
          ram_type = 4;
        end;
      end;
      
      pic = pic .. ';images/terminal_parts/ram_type' .. tostring(ram_type) .. '.png@145,141';
    end;
    
    for idx, slot in ipairs(slots) do
      if slot.device then
        pic = pic .. ';images/terminal_parts/card_' .. tostring(slot.device.visual) .. '.png@' .. tostring(47 + (idx - 1) * 17) .. ',4';
      end;
    end;
    
    return pic;
	end;
	theme = 'tower';
	nam = 'system_unit';
	nofollow = true;
	disp = translate("tower_locale", 'system_unit_disp');
	decor = translate("tower_locale", 'system_unit_decor');
	enter = function(s)
		local motherboard = lookup('#motherboard', _'system_unit');
		local cpu = lookup('#cpu', _'system_unit');
		local ram = lookup('#ram', _'system_unit');
		local slot1 = lookup('#slot1', _'system_unit');
		local slot2 = lookup('#slot2', _'system_unit');
		local slot3 = lookup('#slot3', _'system_unit');
		local slot4 = lookup('#slot4', _'system_unit');
		local slots = {slot1, slot2, slot3, slot4};

		local min = 1;
		if motherboard.device then
			min = motherboard.device.slots + 1;
			cpu:enable();
			ram:enable();
		else
			cpu:disable();
			ram:disable();
		end;

		for i = 1, min - 1 do
			slots[i]:enable();
		end;
		for i = min, #slots do
			slots[i]:disable();
		end;
	end;
	check = function(s, from_solarscale)
		local motherboard = lookup('#motherboard', _'system_unit');
		local cpu = lookup('#cpu', _'system_unit');
		local ram = lookup('#ram', _'system_unit');
		local slot1 = lookup('#slot1', _'system_unit');
		local slot2 = lookup('#slot2', _'system_unit');
		local slot3 = lookup('#slot3', _'system_unit');
		local slot4 = lookup('#slot4', _'system_unit');
		local slots = {slot1, slot2, slot3, slot4};
		stop_sound();
		sounds["pc_startup"]:play(7);

		if not motherboard.device or not motherboard.device.status then
			pc_status = 'fail';
			if from_solarscale then
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_no_sound'));
				return 'motherboard';
			else
        p(translate_now("tower_locale", 'system_unit_check_turn_on'));
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_no_sound'));
				return;
			end;
		end;

		local cpu_valid = false;
		if cpu.device and cpu.device.status then
			if motherboard.device.cpu == 'CAX' then
				cpu_valid = motherboard.device.cpu == cpu.device.slot;
			elseif motherboard.device.cpu == 'CVX' then
				cpu_valid = cpu.device.slot == 'CVX' or cpu.device.slot == 'CAX';
			elseif motherboard.device.cpu == 'CRX' then
				cpu_valid = cpu.device.slot ~= 'CXX';
			end;
		end;

		if not cpu_valid then
			play_sound({false, false, false, false, 'long_beep', false, 'short_beep', 'short_beep'}, 300);
			pc_status = 'fail';
			if from_solarscale then
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_1_long_2_short'));
				return "cpu";
			else
        p(translate_now("tower_locale", 'system_unit_check_turn_on'));
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_1_long_2_short'));
				return;
			end
		end;

		local ram_valid = false;
		if ram.device and ram.device.status then
			if motherboard.device.ram == 'RKT' then
				ram_valid = ram.device.slot == 'RKT';
			elseif motherboard.device.ram == 'RST' then
				ram_valid = ram.device.slot == 'RKT' or ram.device.slot == 'RST';
			elseif motherboard.device.ram == 'RDT' then
				ram_valid = true;
			end;
		end;

		if not ram_valid then
			play_sound({false, false, false, false, 'short_beep', 'long_beep', false, 'long_beep'}, 300);
			pc_status = 'fail';
			if from_solarscale then
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_1_short_2_long'));
				return "ram";
			else
        p(translate_now("tower_locale", 'system_unit_check_turn_on'));
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_1_short_2_long'));
				return;
			end;
		end;

		-- Now we need to find video, keyboard and network
		local video;
		local keyboard;
		local network;
		for i = 1, motherboard.device.slots do
			if slots[i].device then
				if slots[i].device.ptype == 'video' then
					video = slots[i].device;
				elseif slots[i].device.ptype == 'keyboard' then
					keyboard = slots[i].device;
				elseif slots[i].device.ptype == 'network' then
					network = slots[i].device;
				end;
			end;
		end;

		if not video or not video.status then
			play_sound({false, false, false, false,  'long_beep', false, 'short_beep', 'long_beep'}, 300);
			pc_status = 'fail';
			if from_solarscale then
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_1_long_1_short_1_long'));
				return "video";
			else
        p(translate_now("tower_locale", 'system_unit_check_turn_on'));
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_1_long_1_short_1_long'));
				return;
			end;
		end;

		if not keyboard or not keyboard.status then
			play_sound({false, false, false, false, 'long_beep', false, 'long_beep', false, 'long_beep'}, 300);
			pc_status = 'fail';
			if from_solarscale then
				p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_3_long'));
				return "keyboard";
			else
        p(translate_now("tower_locale", 'system_unit_check_turn_on'));
        p(translate_now("tower_locale", 'system_unit_check_fail'));
        p(translate_now("tower_locale", 'system_unit_check_3_long'));
				return;
			end;
		end;
		_('terminal_boot').network = (network and network.status);
		_('terminal_boot').graphical = (video.nam == 'gva-rx4');
    
    pc_status = 'ok';
    
    if not _('terminal_boot').network then
      pc_status = 'fail';
      if from_solarscale then
        p(translate_now("tower_locale", 'system_unit_check_network_fail'));
        return 'network';
      end;
    end;

		if not from_solarscale then
			walkin('terminal_boot');
		end;
	end;
	way = {
		path {translate("common_locale", 'back'), 'tower_level_4_room_2'}
	}
}:with {
	obj {
		nam = '#motherboard';
		device = _'cvx-rst-i3sb';
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'motherboard') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'motherboard') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			local cpu= lookup('#cpu', _'system_unit');
			local ram = lookup('#ram', _'system_unit');
			local slot1 = lookup('#slot1', _'system_unit');
			local slot2 = lookup('#slot2', _'system_unit');
			local slot3 = lookup('#slot3', _'system_unit');
			local slot4 = lookup('#slot4', _'system_unit');

			if cpu.device or ram.device or slot1.device or slot2.device or slot3.device or slot4.device then
				return translate_now("parts_locale", 'motherboard_not_taken');
			end;

			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;

				cpu:disable();
				ram:disable();
				slot1:disable();
				slot2:disable();
				slot3:disable();
				slot4:disable();
        pc_status = 'fail';
				return msg;
			end;
		end;

		used = function(s, o)
			if o.part and o.ptype == 'motherboard' then
				local cpu = lookup('#cpu', _'system_unit');
				local ram = lookup('#ram', _'system_unit');
				local slot1 = lookup('#slot1', _'system_unit');
				local slot2 = lookup('#slot2', _'system_unit');
				local slot3 = lookup('#slot3', _'system_unit');
				local slot4 = lookup('#slot4', _'system_unit');
				local slots = { slot1, slot2, slot3, slot4 };

				if cpu.device or ram.device or slot1.device or slot2.device or slot3.device or slot4.device then
					return translate_now("parts_locale", 'motherboard_not_taken');
				end;

				if s.device then
					return translate_now("parts_locale", 'motherboard_needs_removal');
				end;

				cpu:enable();
				ram:enable();

				for i = 1, o.slots do
					slots[i]:enable();
				end;

				remove(o, pl);
				s.device = o;
        pc_status = 'fail';
				return translate_now("parts_locale", 'motherboard_installed');
			end;
      
      return false;
		end;
	};
	obj {
		nam = '#cpu';
		device = _'mcpu70-cvx-7mhz';
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'cpu') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'cpu') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;
        pc_status = 'fail';
				return msg;
			end;
		end;
		used = function(s, o)
			local motherboard = lookup('#motherboard', _'system_unit');
			if o.part and o.ptype == 'cpu' and motherboard.device then
				if s.device then
					return translate_now("parts_locale", 'cpu_needs_removal');
				end;

				motherboard = motherboard.device;

				if (motherboard.cpu == 'CVX' and (o.slot == 'CRX' or o.slot == 'CXX')) or
					(motherboard.cpu == 'CRX' and o.slot == 'CXX') or
					(motherboard.cpu == 'CAX' and o.slot ~= 'CAX')
				then
					return translate_now("parts_locale", 'cpu_not_fit');
				end;

				remove(o, pl);
				s.device = o;
        if lookup('#ram', _'system_unit').device then
          pc_status = '';
        else
          pc_status = 'fail';
        end;
				return translate_now("parts_locale", 'cpu_installed');
			end;
      return false;
		end;
	};
	obj {
		nam = '#ram';
		device = _'rst-m16-16mb';
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'ram') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'ram') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;
        pc_status = 'fail';
				return msg;
			end;
		end;
		used = function(s, o)
			local motherboard = lookup('#motherboard', _'system_unit');
			if o.part and o.ptype == 'ram' and motherboard.device then
				if s.device then
					return translate_now("parts_locale", 'ram_needs_removal');
				end;

				motherboard = motherboard.device;

				if  (motherboard.ram == 'RST' and o.slot == 'RDT') or
					(motherboard.ram == 'RKT' and o.slot ~= 'RKT')
				then
					return translate_now("parts_locale", 'ram_not_fit');
				end;

				remove(o, pl);
				s.device = o;
        if lookup('#cpu', _'system_unit').device then
          pc_status = '';
        else
          pc_status = 'fail';
        end;
				return translate_now("parts_locale", 'ram_installed');
			end;
      return false;
		end;
	};
	obj {
		nam = '#slot1';
		device = _'tva-rx1';
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;
        pc_status = '';
				return msg;
			end;
		end;
		used = function(s, o)
			local motherboard = lookup('#motherboard', _'system_unit');
			if o.part and (o.ptype == 'video' or o.ptype == 'network' or o.ptype == 'keyboard') and motherboard.device then
				if s.device then
					return translate_now("parts_locale", 'device_needs_removal');
				end;

				remove(o, pl);
				s.device = o;
        pc_status = '';
				return translate_now("parts_locale", 'device_installed');
			end;
      return false;
		end;
	};
	obj {
		nam = '#slot2';
		device = _'kbc-s';
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;
        pc_status = '';
				return msg;
			end;
		end;
		used = function(s, o)
			local motherboard = lookup('#motherboard', _'system_unit');
			if o.part and (o.ptype == 'video' or o.ptype == 'network' or o.ptype == 'keyboard') and motherboard.device then
				if s.device then
					return translate_now("parts_locale", 'device_needs_removal');
				end;

				remove(o, pl);
				s.device = o;
        pc_status = '';
				return translate_now("parts_locale", 'device_installed');
			end;
      return false;
		end;
	};
	obj {
		nam = '#slot3';
		device = _'fna-100-10mbs_1';
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;
        pc_status = '';
				return msg;
			end;
		end;
		used = function(s, o)
			local motherboard = lookup('#motherboard', _'system_unit');
			if o.part and (o.ptype == 'video' or o.ptype == 'network' or o.ptype == 'keyboard') and motherboard.device then
				if s.device then
					return translate_now("parts_locale", 'device_needs_removal');
				end;

				remove(o, pl);
				s.device = o;
        pc_status = '';
				return translate_now("parts_locale", 'device_installed');
			end;
      return false;
		end;
	};
	obj {
		nam = '#slot4';
		device = false;
		dsc = function(s)
			if s.device then
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. s.device.name .. '}^';
			else
				return '{' .. translate_now("parts_locale", 'slot') .. ': ' .. translate_now("parts_locale", 'component_not_set') .. '}^';
			end;
		end;
		act = function(s)
			if s.device then
        local msg = std.call(_(s.device), 'tak');
				take(s.device);
				s.device = false;
        pc_status = '';
				return msg;
			end;
		end;
		used = function(s, o)
			local motherboard = lookup('#motherboard', _'system_unit');
			if o.part and (o.ptype == 'video' or o.ptype == 'network' or o.ptype == 'keyboard') and motherboard.device then
				if s.device then
					return translate_now("parts_locale", 'device_needs_removal');
				end;

				remove(o, pl);
				s.device = o;
        pc_status = '';
				return translate_now("parts_locale", 'device_installed');
			end;
      return false;
		end;
	};
}

room {
	light = false;
	nam = 'tower_level_3_room_2';
	disp = translate("tower_locale", 'tower_level_3_room_2_disp');
	theme = 'tower';
	pic = function(s)
		if power_on then
			return 'images/tower_level_3_room_2_power.png';
		elseif s.light then
			return 'images/tower_level_3_room_2_light.png';
		else
			return 'images/tower_level_3_room_2_dark.png';
		end;
	end;
	decor = function(s)
		if s.light then
			return translate_now("tower_locale", 'tower_level_3_room_2_decor_lit');
		else
			return translate_now("tower_locale", 'tower_level_3_room_2_decor_dark');
		end;
	end;
	way = {
		path {translate("tower_locale", 'transition_upstairs'), 'tower_level_4_room_2'};
		path {'level_3_main_room', translate("tower_locale", 'transition_study'), 'tower_level_3'}:disable();
		path {'level_3_room_2_down', translate("tower_locale", 'transition_downstairs'), 'tower_level_2_room_2'}:disable();
	};
}:with {
	obj {
		nam = '#ladder';
		act = translate("tower_locale", 'tower_level_3_room_2_ladder_up');
	};
	obj {
		nam = '#ladder_down';
		act = translate("tower_locale", 'tower_level_3_room_2_ladder_down');
	};
	obj {
		nam = '#floor';
		act = translate("tower_locale", 'tower_level_3_room_2_floor');
	};
	obj {
		nam = '#walls';
		act = translate("tower_locale", 'tower_level_3_room_2_walls');
	};
	obj {
		nam = '#ceiling';
		act = function(s)
			if power_on then
				return translate_now("tower_locale", 'tower_level_3_room_2_ceiling_power');
			else
				return translate_now("tower_locale", 'tower_level_3_room_2_ceiling');
			end;
		end;
	};
	obj {
		nam = '#darkness';
		used = function(s, o)
			if o^'potion_light' then
				remove('potion_light', pl);
				here().light = true;
				_'#door':enable();
				_'#shelves':enable();
				_'level_3_room_2_down':enable()
				s:disable();
				return translate_now("tower_locale", 'potion_light_inv_used');
			elseif o^'candle' then
				return translate_now("tower_locale", 'tower_level_3_room_2_darkness_used_candle');
			end;
			return false;
		end;
		act = translate("tower_locale", 'tower_level_3_room_2_darkness');
	};
	obj {
		nam = '#door';
		dsc = function(s)
			if _ 'level_3_main_room':disabled() then
				return translate_now("tower_locale", 'tower_level_3_room_2_door_dsc_closed');
			else
				return translate_now("tower_locale", 'tower_level_3_room_2_door_dsc_opened');
			end;
		end;
		act = function(s)
			if _ 'level_3_main_room':disabled() then
				_ 'level_3_main_room':enable();
				_('level_3_next_room', 'tower_level_3'):enable();
				_('level_3_room_2_door', 'tower_level_3'):enable();
				return translate_now("tower_locale", 'tower_level_3_room_2_door_act_open');
			else
				return translate_now("tower_locale", 'tower_level_3_room_2_door_act_opened');
			end;
		end;
	}:disable();
	obj {
		state = 0;
		nam = '#shelves';
		act = function(s)
			if not here().light then
				return translate_now("tower_locale", 'tower_level_3_room_2_darkness');
			elseif s.state == 0 then
				s.state = 1;
				take('tool_box');
				take('emerald');
				_'part_box':enable();
				return translate_now("tower_locale", 'tower_level_3_room_2_shelves_act_first');
			else
				return translate_now("tower_locale", 'tower_level_3_room_2_shelves_act_second');
			end;
		end;
	};
	'part_box';
}

room {
	nam = 'tower_level_2_room_2';
	theme = 'tower';
	pic = function(s)
		if power_on then
			return 'images/tower_level_2_room_2_light.png';
		else
			return 'images/tower_level_2_room_2_dark.png';
		end;
	end;
	disp = translate("tower_locale", 'tower_level_2_room_2_disp');
	onenter = function(s)
		if have('protection_suit', pl) then
			put('protection_suit', 'tower_level_2_airlock_cabinet');
			remove('protection_suit', pl);
			return translate_now("tower_locale", 'tower_level_2_remove_suit');
		end;
	end;
	decor = function(s)
    p(translate_now("tower_locale", 'tower_level_2_room_2_decor'));
		if power_on then
			p(translate_now("tower_locale", 'tower_level_2_room_2_decor_power'));
		else
			p(translate_now("tower_locale", 'tower_level_2_room_2_decor_nopower'));
		end;
	end;
	way = {
		path {translate("tower_locale", 'transition_upstairs'), 'tower_level_3_room_2'};
		path {translate("tower_locale", 'transition_airlock'), 'tower_level_2_airlock'};
		path {'level_2_main_room', translate("tower_locale", 'transition_lab'), 'tower_level_2'}:disable();
		path {translate("tower_locale", 'transition_downstairs'), 'tower_level_1_room_2'};
	}
}:with {
	'tower_walls';
	obj {
		nam = '#floor';
		act = translate("tower_locale", 'tower_level_2_room_2_floor');
	};
	obj {
		nam = '#ceiling';
		act = translate("tower_locale", 'tower_level_2_room_2_ceiling');
	};
	obj {
		nam = '#lamps';
		act = translate("tower_locale", 'tower_level_2_room_2_lamps');
	};
	obj {
		nam = '#emergency_lamps';
		act = translate("tower_locale", 'tower_level_2_room_2_emergency_lamps');
	};
	obj {
		nam = '#reactor_door';
		dsc = translate("tower_locale", 'tower_level_2_room_2_reactor_door_dsc');
		act = translate("tower_locale", 'tower_level_2_room_2_reactor_door_act');
	};
	obj {
		nam = '#control_panel';
		dsc = translate("tower_locale", 'tower_level_2_room_2_control_panel_dsc');
		act = function(s)
			walkin('reactor_control_panel');
		end;
	};
	obj {
		nam = '#next_door';
		dsc = function(s)
			if _'level_2_main_room':disabled() then
				return translate_now("tower_locale", 'tower_level_2_room_2_next_door_dsc_closed');
			else
				return translate_now("tower_locale", 'tower_level_2_room_2_next_door_dsc_open');
			end;
		end;
		act = function(s)
			if _'level_2_main_room':disabled() then
				_'level_2_main_room':enable();
				_'level_2_next_room':enable();
				return translate_now("tower_locale", 'tower_level_2_room_2_next_door_act_closed');
			else
				return translate_now("tower_locale", 'tower_level_2_room_2_next_door_act_open');
			end;
		end;
	}
}

dlg {
	theme = 'tower';
	nam = 'reactor_control_panel';
	disp = translate("tower_locale", 'reactor_control_panel_disp');
	pic = function(s)
		if power_on then
			return 'images/tower_level_2_room_2_light.png';
		else
			return 'images/tower_level_2_room_2_dark.png';
		end;
	end;
	enter = translate("tower_locale", 'reactor_control_panel_enter');
	phr = {
		{always=true, translate("tower_locale", 'reactor_control_panel_diagnostic'), function(s)
			pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_1'));
			pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_2'));
			pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_3'));
			pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_4'));
			if rods_raised then
				pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_performance') .. ' 0%');
				pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_rods_up'));
			elseif rods_enriched then
        pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_performance') .. ' 101%');
				pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_rods_ok'));
			else
				pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_performance') .. ' 1%');
				pn(translate_now("tower_locale", 'reactor_control_panel_diagnostic_resp_rods_bad'));
			end;
		end;};
		{cond=function(s) return not rods_raised; end; always=true; translate("tower_locale", 'reactor_control_panel_raise_rods'), function(s)
			rods_raised = true;
			power_on = false;
			return translate_now("tower_locale", 'reactor_control_panel_rods_response')
		end;};
		{cond=function(s) return rods_raised; end; always=true; translate("tower_locale", 'reactor_control_panel_lower_rods'), function(s)
			rods_raised = false;
			pr(translate_now("tower_locale", 'reactor_control_panel_rods_response'));
			if rods_enriched then
				power_on = true;
			end;
		end;};
		{translate("tower_locale", 'reactor_control_panel_leave'), function(s)
			walkout();
		end;};
	};
}

room {
	theme = 'tower';
	nam = 'tower_level_2_airlock';
	pic = function(s)
		if power_on then
			return 'images/tower_level_2_room_2_light.png';
		else
			return 'images/tower_level_2_room_2_dark.png';
		end;
	end;
	disp = translate("tower_locale", 'tower_level_2_airlock_disp');
	decor = translate("tower_locale", 'tower_level_2_airlock_decor');
	way = {
		path {translate("tower_locale", 'transition_control'), 'tower_level_2_room_2'};
		path {translate("tower_locale", 'transition_reactor'), 'tower_level_2_reactor'};
	};
}: with {
	obj {
		nam = '#walls';
		act = translate("tower_locale", 'tower_level_2_airlock_walls');
	};
	obj {
		nam = '#ceiling';
		act = translate("tower_locale", 'tower_level_2_airlock_ceiling');
	};
	obj {
		nam = '#lamp';
		act = translate("tower_locale", 'tower_level_2_airlock_lamp');
	};
	obj {
		nam = 'tower_level_2_airlock_cabinet';
		dsc = translate("tower_locale", 'tower_level_2_airlock_locker_dsc');
		act = translate("tower_locale", 'tower_level_2_airlock_locker_act');
		used = function(s, o)
			if o^'protection_suit' then
				put('protection_suit', 'tower_level_2_airlock_cabinet');
				remove('protection_suit', pl);
				return translate_now("tower_locale", 'tower_level_2_remove_suit');
			end;
      
      return false;
		end;
	}:with {
		obj {
			nam = 'protection_suit';
			disp = translate("tower_locale", 'protection_suit_disp');
			dsc = translate("tower_locale", 'protection_suit_dsc');
			tak = translate("tower_locale", 'protection_suit_tak');
			inv = function(s)
				if here()^'tower_level_2_reactor' then
					return translate_now("tower_locale", 'protection_suit_inv_not_here');
				else
					put('protection_suit', here());
					remove('protection_suit', pl)
					return translate_now("tower_locale", 'protection_suit_inv_remove');
				end;
			end;
		};
	};
}

room {
	theme = 'tower';
	nam = 'tower_level_2_reactor';
	theme = 'tower';
	pic = function(s)
		if rods_raised then
			if not rods_enriched then
				return 'images/tower_level_2_reactor_rods_up.png';
			end;
			
			return 'images/tower_level_2_reactor_rods_enriched.png';
		elseif power_on then
			return 'images/tower_level_2_reactor_on.png';
		else
			return 'images/tower_level_2_reactor_off.png';
		end;
	end;
	nofollow = function(s)
		if here():from()^'tower_level_2_airlock' then
			return translate_now("solarscale_locale", 'follow_refuse') .. ' ' ..translate_now("solarscale_locale", 'follow_refuse_reactor');
		else
			return true;
		end;
	end;
	disp = translate("tower_locale", 'tower_level_2_reactor_disp');
	onenter = function(s)
		if not have('protection_suit', pl) then
			if solarscale_with_me then
        p(translate_now("tower_locale", 'tower_level_2_reactor_enter_solarscale'));
				return false;
			else
        if not irradiated then
          sounds['irradiated']:play();
        end;
				irradiated = true;
				return translate_now("tower_locale", 'tower_level_2_reactor_enter_alone');
			end;
		end;
	end;
	way = {
		path {translate("tower_locale", 'transition_airlock'), 'tower_level_2_airlock'};
	};
}: with {
	obj {
		nam = '#reactor_rods';
		dsc = function(s)
			if rods_raised then
				return translate_now("tower_locale", 'tower_level_2_reactor_rods_dsc_raised');
			else
				return translate_now("tower_locale", 'tower_level_2_reactor_rods_dsc_lowered');
			end;
		end;
		act = function(s)
			if rods_raised then
				return translate_now("tower_locale", 'tower_level_2_reactor_rods_act_raised');
			else
				return translate_now("tower_locale", 'tower_level_2_reactor_rods_act_lowered');
			end;
		end;
		used = function(s, o)
			if o^'potion_enrichment' and rods_raised then
				remove('potion_enrichment', pl);
				rods_enriched = true;
				return translate_now("tower_locale", 'tower_level_2_reactor_rods_used');
			else
				return false;
			end;
		end;
	}
}

room {
	theme = 'tower';
	nam = 'tower_level_1_room_2';
	disp = translate("tower_locale", 'tower_level_1_room_2_disp');
	pic = 'images/tower_level_1_room_2.png';
	decor = translate("tower_locale", 'tower_level_1_room_2_decor');
	way = {
		path {translate("tower_locale", 'transition_upstairs'), 'tower_level_2_room_2'};
		path {'level_1_main_room', translate("tower_locale", 'transition_dining_room'), 'tower_level_1'}:disable();
	};
}: with {
	obj {
		nam = '#kitchen_sink';
		act = translate("tower_locale", 'tower_level_1_room_2_kitchen_sink');
		used = function(s, o)
			if o ^ 'kettle' then
				if o.state == 0 then
					o.state = 1;
					return translate_now("tower_locale", 'tower_level_1_room_2_kitchen_sink_used_water');
				else
					return translate_now("tower_locale", 'tower_level_1_room_2_kitchen_sink_used_full');
				end;
      else
        return false;
			end;
		end;
	};
	obj {
		nam = '#tabletop';
		act = translate("tower_locale", 'tower_level_1_room_2_tabletop');
    used = function(s, o)
      if o^'cups' then
        remove('cups', me());
        put('cups', here());
        return translate_now("tower_locale", 'tower_level_1_room_2_put_cups');
      end;
      
      return false;
    end;
	};
	obj {
		state = 0;
		nam = '#cabinets1';
		act = function(s)
			if solarscale_with_me and s.state == 0 then
        if not _'solarscale_ally'.tea_asked then
          _'solarscale_ally'.tea_found = true;
          return translate_now("tower_locale", 'tower_level_1_room_2_cabinets1_act_tea_ask');
        else
          s.state = 1;
          take('teabox');
          take('teapot');
          return translate_now("tower_locale", 'tower_level_1_room_2_cabinets1_act_tea_and_teapot');
        end;
			end;
		
			return translate_now("tower_locale", 'tower_level_1_room_2_cabinets_act_empty');
		end;
	};
	obj {
		state = 0;
		nam = '#cabinets2';
		act = function(s)
			if s.state < 3 then
				if s.state == 0 then
					s.state = 1;
					take('password_note');
					return translate_now("tower_locale", 'tower_level_1_room_2_cabinets2_act_note');
				elseif _'solarscale_ally'.tea_asked then
					if s.state == 1 then
						s.state = 2;
            take('cups');  
						return translate_now("tower_locale", 'tower_level_1_room_2_cabinets2_act_cups');
					end;
				end;
			end;
			return translate_now("tower_locale", 'tower_level_1_room_2_cabinets_act_empty');
		end;
	};
	obj {
		nam = '#fridge';
		act = translate("tower_locale", 'tower_level_1_room_2_fridge');
	};
	obj {
		nam = '#stove';
		act = translate("tower_locale", 'tower_level_1_room_2_stove_act');
		used = function(s, o)
			if o ^ 'kettle' then
				if power_on then
					if o.state == 0 then
						return translate_now("tower_locale", 'kettle_boil_empty');
					elseif o.state == 2 then
						return translate_now("tower_locale", 'tower_level_1_room_2_stove_used_hot');
					else
						o.state = 2;
						return translate_now("tower_locale", 'tower_level_1_room_2_stove_used_teapot');
					end;
				else
					return translate_now("tower_locale", 'tower_level_1_room_2_stove_used_power');
				end;
      else
        return false;
			end;
		end;
	};
	obj {
		nam = 'silver_fork';
		disp = translate("tower_locale", 'silver_fork_disp');
		disp2 = translate("tower_locale", 'silver_fork_disp2');
		disp3 = translate("tower_locale", 'silver_fork_disp3');
		inv = translate("tower_locale", 'silver_fork_inv');
		dsc = translate("tower_locale", 'silver_fork_dsc');
		tak = translate("tower_locale", 'silver_fork_tak');
	};
	obj {
		state = 0;
		nam = '#door';
		dsc = translate("tower_locale", 'tower_level_1_room_2_door_dsc');
		act = function(s)
			if s.state == 0 then
				return translate_now("tower_locale", 'tower_level_1_room_2_door_act_locked');
			else
				return translate_now("tower_locale", 'tower_level_1_room_2_door_act_open');
			end;
		end;
		used = function(s, o)
			if o^'kitchen_key' then
				s.state = 1;
				remove('kitchen_key', pl);
				_'level_1_main_room':enable();
				_'level_1_next_room':enable();
				return translate_now("tower_locale", 'tower_level_1_room_2_door_used');
      else
        return false;
			end;
		end;
	};
	obj {
		key_taken = false;
		nam = '#hook';
		dsc = function(s)
			if s.key_taken then
				 return translate_now("tower_locale", 'tower_level_1_room_2_hook_dsc_empty');
			else
				return translate_now("tower_locale", 'tower_level_1_room_2_hook_dsc_key');
			end;
		end;
		act = function(s)
			if s.key_taken then
				return translate_now("tower_locale", 'tower_level_1_room_2_hook_act_empty');
			else
				take('kitchen_key');
				s.key_taken = true;
				return translate_now("tower_locale", 'tower_level_1_room_2_hook_act_key');
			end;
		end;
	};
  'kettle';
}

obj {
	nam = 'kitchen_key';
	disp = translate("tower_locale", 'kitchen_key_disp');
	disp2 = translate("tower_locale", 'kitchen_key_disp2');
	disp3 = translate("tower_locale", 'kitchen_key_disp3');
	inv = translate("tower_locale", 'kitchen_key_inv');
};

obj {
	nam = 'part_box';
	disp = translate("tower_locale", 'part_box_disp');
	disp2 = translate("tower_locale", 'part_box_disp2');
	disp3 = translate("tower_locale", 'part_box_disp3');
	inv = function(s)
		walkin('part_box_inside');
	end;
	used = function(s, o)
		if o.part then
			remove(o, pl);
			put(o, 'part_box_inside');
			return translate_now("tower_locale", 'part_box_used');
		end;
    
    return false;
	end;
	dsc = translate("tower_locale", 'part_box_dsc');
	tak = translate("tower_locale", 'part_box_tak');
}:disable();

room {
	nam = 'part_box_inside';
	theme = 'tower';
	nofollow = true;
	pic = function(s)
    if from() then
      return std.call(from(), 'pic');
    else
      return
    end;
	end;
	disp = translate("tower_locale", 'part_box_disp');
	dsc = translate("tower_locale", 'part_box_inside_dsc');
	way = {
		path {translate("common_locale", 'back'), function(s) return here():from() end;};
	}
}:with {
	'cax-rkt-i2sb',
	'cax-rkt-i3sb',
	'cax-rst-i2sb',
	'cax-rst-i3sb',
	'cvx-rst-i2sb',
	'cvx-rst-i4sb',
	'cvx-rdt-i2sb',
	'crx-rst-i3sb',
	'crx-rdt-i2sb',
	'crx-rdt-i3sb',

	'cpu20-cax-2mhz',
	'cpu40-cax-4mhz',
	'mcpu50-cvx-5mhz',
	'mcpu70-cvx-7mhz_2',
	'rcpu100-crx-10mhz',
	'rcpu200-crx-20mhz',
	'xcpu100-cxx-100mhz',

	'rkt-m20-2mb',
	'rkt-m40-4mb',
	'rst-m8-8mb',
	'rst-m16-16mb_2',
	'rdt-m32-32mb',
	'rdt-m64-64mb',

	'tva-rx2',
	'gva-rx2',
	'gva-rx4',

	'fna-200-20mbs',
	'fna-100-10mbs_2',
	'fna-50-5mbs',

	'kbc-s_2',
	'kbc-r',
	'kbc-p'
}

room {
	nam = 'terminal_manual';
	theme = 'tower';
	pic = function(s)
		if power_on then
			return 'images/tower_level_4_room_2_light.png';
		else
			return 'images/tower_level_4_room_2_dark.png';
		end;
	end;
	nofollow = true;
	disp = translate("tower_locale", 'terminal_manual_disp');
	dsc = translate("tower_locale", 'terminal_manual_dsc');
	way = {
		path {translate("common_locale", 'back'), 'tower_level_4_room_2'};
	}
}

room {
	nam = 'service_manual';
	theme = 'tower';
	nofollow = true;
	disp = translate("tower_locale", 'service_manual_disp');
	pic = function(s)
		if power_on then
			return 'images/tower_level_4_room_2_light.png';
		else
			return 'images/tower_level_4_room_2_dark.png';
		end;
	end;
	dsc = translate("tower_locale", 'service_manual_dsc');
	way = {
		path {translate("common_locale", 'back'), 'terminal_manual'};
	}
}

room {
	nam = 'troubleshooting_manual';
	theme = 'tower';
	nofollow = true;
	pic = function(s)
		if power_on then
			return 'images/tower_level_4_room_2_light.png';
		else
			return 'images/tower_level_4_room_2_dark.png';
		end;
	end;
	disp = translate("tower_locale", 'troubleshooting_manual_disp');
	dsc = translate("tower_locale", 'troubleshooting_manual_dsc');
	way = {
		path {translate("common_locale", 'back'), 'terminal_manual'};
	}
}
